PROGRAM Dessin;                              {31/07/94 par: Lad MESSAOUDI }
{$R+} {$S+}

USES    Graph, Imane, Mouse, Cursors, Crt, Imane2D;

CONST   Cf = 9;                                { Couleur de fond }

VAR     GraphPilot, GraphMode      : Integer;
        MaxX, MaxY, NbreCouleurs   : Integer;
        FenPr                      : Bouton;
        FenHG, FenHD, FenBG, FenBD : Bouton;
        ZoneMessages               : Bouton;
        BoutRac                    : Array[0..9] Of Bouton;
        Fen                        : Array[0..4] Of Bouton;
        X1f, X2f, Y1f, Y2f         : Integer;
        X1f1, X2f1, Y1f1, Y2f1     : Integer;
        X1f2, X2f2, Y1f2, Y2f2     : Integer;
        X1f3, X2f3, Y1f3, Y2f3     : Integer;
        X1f4, X2f4, Y1f4, Y2f4     : Integer;
        i,k, BtnCount              : Integer;
        GMouse                     : GraphicMouse;
        mButton                    : Position;
        Status, Exit               : Boolean;
        LongTitre                  : Byte;
        XPos, YPos, BtnStatus      : Integer;
        XPosStr, YPosStr           : String;
        QuelMenu                   : Integer;




{===========================================================================}
PROCEDURE INITIALISATION_CARTE_GRAPHIQUE (Chemin : String);

Var    ErrorCode : Integer;

BEGIN
       GraphPilot:=Detect;
       InitGraph(GraphPilot,GraphMode,Chemin);
       ErrorCode := GraphResult;
       if ErrorCode <> GrOk Then
          Begin
               WriteLn ('Erreur graphique : ',GraphErrorMsg(ErrorCode));
               Halt (1)
          End;
   MaxX := GetMaxX;
   MaxY := GetMaxY;
   NbreCouleurs := GetMaxColor;
END;

{===========================================================================}
PROCEDURE INITIALISATION_OBJETS;

BEGIN
     FenPr.Init(0,0,0,0);
     FenHG.Init(0,0,0,0);
     FenHD.Init(0,0,0,0);
     FenBG.Init(0,0,0,0);
     FenBD.Init(0,0,0,0);
     ZoneMessages.Init(0,0,0,0);

     For i:=1 To 9 Do
              Begin
                   BoutRac[i].Init(0,0,0,0);
              End;
     For k:=1 To 4 Do
              Begin
                   Fen[k].Init(0,0,0,0);
              End;
END;

{===========================================================================}
PROCEDURE Ecrit_BtnRac;

Begin
       BoutRac[1].SetTexte(549,385,574,410,'G',14);
       BoutRac[2].SetTexte(579,385,604,410,'D',14);
       BoutRac[3].SetTexte(609,385,634,410,'P',14);
       BoutRac[4].SetTexte(549,415,574,440,'S',10);
       BoutRac[9].SetTexte(609,445,634,470,'E',14);
End;

{===========================================================================}
PROCEDURE Position_Souris;

Begin
     SetFillStyle(1,9);
     Bar(435,7,500,17);
     Bar(505,7,545,17);
     GMouse.GetPosition(BtnStatus,XPos, YPos);

     Str(XPos,XPosStr);           Str(YPos,YPosStr);

     SetColor(14);
     OutTextXY(420,10,'X= '+ XPosStr);
     OutTextXY(490,10,'Y= '+ YPosStr);

End;

{===========================================================================}
PROCEDURE FOND_MENU;

BEGIN
     X1f := 2;    Y1f := 20;   X2f := 544;  Y2f := 442;

     ClearDevice;
     SetColor(13);
     Rectangle(0,0,MaxX,MaxY);
     SetFillStyle(1,9);
     Bar(1,1,MaxX-1,MaxY-1);

     With ZoneMessages Do
          Begin
               SetType(PBouton);
               SetCouleur(7,Cf,7);
               SetPosition(2,444,MaxX-100,MaxY-2,2);
               Etat:= False;
               Affiche;
          End;

     With FenPr Do
          Begin
               SetType(PBouton);
               Etat := True;
               SetCouleur(3,Cf,3);
               SetPosition(X1f  ,Y1f,X2f-5,Y2f,0);
               Affiche;
          End;

    BoutRac[1].SetPosition(549,385,574,410,0);
    BoutRac[2].SetPosition(579,385,604,410,0);
    BoutRac[3].SetPosition(609,385,634,410,0);
    BoutRac[4].SetPosition(549,415,574,440,0);
    BoutRac[5].SetPosition(579,415,604,440,0);
    BoutRac[6].SetPosition(609,415,634,440,0);
    BoutRac[7].SetPosition(549,445,574,470,0);
    BoutRac[8].SetPosition(579,445,604,470,0);
    BoutRac[9].SetPosition(609,445,634,470,0);

    For i:=1 To 9 Do
        Begin
             With BoutRac[i] Do
                Begin
                     SetType(PBouton);
                     SetCouleur(7,Cf,7);
                     Etat := True;
                     Affiche;
                End;
        End;
END;

{===========================================================================}
PROCEDURE FOND_MENU1;

BEGIN
     QuelMenu := 1;
     X1f1 := 2;    Y1f1 := 20;   X2f1 := 272;  Y2f1 := 230;
     X1f2 := 274;  Y1f2 := 20;   X2f2 := 544;  Y2f2 := 230;
     X1f3 := 2;    Y1f3 := 232;  X2f3 := 272;  Y2f3 := 442;
     X1f4 := 274;  Y1f4 := 232;  X2f4 := 544;  Y2f4 := 442;

     ClearDevice;
     SetColor(13);
     Rectangle(0,0,MaxX,MaxY);
     SetFillStyle(1,9);
     Bar(1,1,MaxX-1,MaxY-1);
     SetFillStyle(1,8);

     With ZoneMessages Do
          Begin
               SetType(PBouton);
               SetCouleur(7,Cf,7);
               SetPosition(2,444,MaxX-100,MaxY-2,2);
               Etat:= False;
               Affiche;
          End;

     With FenHG, FenHD, FenBG, FenBD Do
          Begin
               SetType(PBouton);
               Etat := True;
               SetCouleur(3,Cf,3);
               SetPosition(X1f1  ,Y1f1,X2f1-5,Y2f1,0);Affiche;
               SetPosition(X1f2-5,Y1f2,X2f2-5,Y2f2,0);Affiche;
               SetPosition(X1f3  ,Y1f3,X2f3-5,Y2f3,0);Affiche;
               SetPosition(X1f4-5,Y1f4,X2f4-5,Y2f4,0);Affiche;
               SetColor(14);
                 OutTextXY(8,25,'Face');
                  OutTextXY(275,25,'Gauche');
                   OutTextXY(8,238,'Dessus');
                    OutTextXY(275,238,'Perspective');
          End;

    BoutRac[1].SetPosition(549,385,574,410,0);
    BoutRac[2].SetPosition(579,385,604,410,0);
    BoutRac[3].SetPosition(609,385,634,410,0);
    BoutRac[4].SetPosition(549,415,574,440,0);
    BoutRac[5].SetPosition(579,415,604,440,0);
    BoutRac[6].SetPosition(609,415,634,440,0);
    BoutRac[7].SetPosition(549,445,574,470,0);
    BoutRac[8].SetPosition(579,445,604,470,0);
    BoutRac[9].SetPosition(609,445,634,470,0);

    For i:=1 To 9 Do
        Begin
             With BoutRac[i] Do
                Begin
                     SetType(PBouton);
                     SetCouleur(7,Cf,7);
                     Etat := True;
                     Affiche;
                End;
        End;
     Ecrit_BtnRac;
END;

{===========================================================================}
PROCEDURE AXES;

Begin

End;
{===========================================================================}
PROCEDURE FOND_MENU2;

BEGIN
     QuelMenu := 2;
     Fond_Menu;
     Ecrit_BtnRac;
     Axes;
END;

{===========================================================================}
PROCEDURE A_PROPOS;

BEGIN
     With Fen[1] Do
          Begin
               SetType(PBouton);
               SetCouleur(7,3,13);
               Etat := True;
               SetPosition(70,50,550,430,5);
               Affiche;
          End;
     With Fen[2] Do
          Begin
               SetType(PBouton);
               SetCouleur(7,3,13);
               Etat := False;
               SetPosition(70,50,550,430,5);
               Affiche;
          End;
     With Fen[3] Do
          Begin
               SetType(PBouton);
               SetCouleur(1,3,1);
               Etat := False;
               SetPosition(90,65,530,100,0);
               Affiche;
               SetTextStyle(4,0,2);
               SetColor(14);
               OutTextXY(250,67,'A Propos de...');
               SetTextStyle(0,0,0);
          End;
      With Fen[4] Do
          Begin
               SetType(PBouton);
               SetCouleur(7,3,1);
               Etat := False;
               SetPosition(110,130,510,400,0);
               Affiche;
               SetColor(1);
               OutTextXY(255,150,'Dessin V 1.0');
               OutTextXY(125,180,'Logiciel de dessin intgrant les modules :');
               OutTextXY(145,200,'- Transformations dans le plan,');
               OutTextXY(145,220,'- Trac de courbes paramtriques,');
               OutTextXY(145,240,'- Trac de bolygones,');
               OutTextXY(145,260,'- Trac de fractales,');
               OutTextXY(145,280,'- Dessin Technique.');
               SetColor(14);
               OutTextXY(125,340,'Ce logiciel est ralis avec TurboPascal V 5.5.');

               SetColor(15);
               OutTextXY(170,370,'Copyrite 1994 by : Lad MESSAOUDI.');
          End;
END;

{===========================================================================}
PROCEDURE MENU_PRINCIPAL;

BEGIN
     QuelMenu := 0;
     Fond_Menu;
     SetColor(10);
       OutTextXY(570,8,'MENU');
         OutTextXY(555,22,'PRINCIPAL');
     SetColor(15);
       OutTextXY(550,60,'Fichier');
       OutTextXY(550,250,'Quitter');
     Ecrit_BtnRac;
     BoutRac[8].SetTexte(579,445,604,470,'A',14);
END;

{===========================================================================}
PROCEDURE CHOIX;

BEGIN

GMouse.Reset (Status, BtnCount);
 Exit := False;
  If Status Then
  Begin
       GMouse.Initialize;
       GMouse.SetCursor (LaidCur1);
       Position_Souris;
       Repeat
             GMouse.QueryBtnDn (ButtonL, mButton);
             If mButton.OpCount > 0 Then
             Begin
                  GMouse.Show (False);
                  Position_Souris;
                  If QuelMenu = 0 Then
                  If (XPos > 549) And (YPos > 249) And
                     (XPos < 605) And (YPos < 258) Then Exit:=True;

                  For i:= 1 To 9 Do
                  Begin
                  If BoutRac[i].BoutonHit (mButton.XPos, mButton.YPos) Then
                  Begin
                       GMouse.Show (True);
                       If i=1 Then
                          Begin
                               GMouse.Show (False);
                               Menu_Principal;
                               Choix;
                               GMouse.Show (True);
                          End;
                       If i=2 Then
                          Begin
                               GMouse.Show (False);
                               Fond_Menu1;
                               Choix;
                               GMouse.Show (True);
                          End;
                       If i=3 Then
                          Begin
                               GMouse.Show (False);
                               Fond_Menu2;
                               Choix;
                               GMouse.Show (True);
                          End;
                       If i=4 Then
                          Begin
                               If BoutRac[4].Etat Then
                                  GMouse.SetCursor (LaidCur1)
                                  Else GMouse.SetCursor (LaidCur2);
                          End;
                       If i=8 Then If QuelMenu = 0 Then
                          Begin
                               If BoutRac[8].Etat Then
                               Begin
                                    GMouse.Show (False);
                                    Menu_Principal;
                                    Choix;
                                    GMouse.Show (True);
                               End
                               Else
                               Begin
                                    GMouse.Show (False);
                                    BoutRac[8].SetTexte(579,445,604,470,'A',8);
                                    A_Propos;
                                    GMouse.SetLimits(579,445,604,470);
                                    GMouse.Show (True);
                               End;
                          End;
                       If i=9 Then
                              Begin
                                   Delay(100);
                                   Exit := True;
                              End;
                  End;
                  End;
                  GMouse.Show (True);
             End;
       Until Exit;
  End;
END;

{===========================================================================}
{***************************************************************************}
{========================= Programme principal =============================}
{***************************************************************************}

BEGIN
     INITIALISATION_CARTE_GRAPHIQUE ('C:\TP7\BGI');
     INITIALISATION_OBJETS;
     MENU_PRINCIPAL;
     CHOIX;
     CloseGraph;
END.