PROGRAM Dessin_Reacteur;             {par Lad Messaoudi - 1996}

USES
   Crt, Dos, Graph;

CONST
    Motif1 : FillPatternType = ($CC, $15, $BD,
      $15, $BC, $15, $BD, $15);

VAR
   x1,y1,x2,y2              : Integer;


{==========================================================================}
PROCEDURE INITIALISATION_CARTE_GRAPHIQUE(CheminGraph : String);

VAR
    GraphPilot, GraphMode : Integer;

BEGIN
       GraphPilot := Detect;
        InitGraph(GraphPilot,GraphMode,CheminGraph);
        If GraphResult <> GrOk Then
       Halt(1);
END;

{***************************************************************************}
PROCEDURE BOUTON1S(Hor1,Ver1,Hor2,Ver2 : Integer; CoulBouton : Word);

BEGIN
      SetFillStyle(1,CoulBouton);
      Bar(Hor1,Ver1,Hor2,Ver2);
      SetLineStyle(0,1,1);
      SetColor(Black);
      Rectangle(Hor1,Ver1,Hor2,Ver2);
      SetColor(15);
      Line(Hor1,Ver1,Hor2,Ver1);
      Line(Hor1,Ver1,Hor1,Ver2-1);

END;

{**************************************************************************}
PROCEDURE BOUTON1S_M(Hor1,Ver1,Hor2,Ver2 : Integer; CoulBouton, Motif_B : Word);

BEGIN
      SetFillStyle(Motif_B,CoulBouton);
      Bar(Hor1,Ver1,Hor2,Ver2);
      SetLineStyle(0,1,1);
      SetColor(Black);
      Rectangle(Hor1,Ver1,Hor2,Ver2);
      SetColor(15);
      Line(Hor1,Ver1,Hor2,Ver1);
      Line(Hor1,Ver1,Hor1,Ver2-1);

END;

{***************************************************************************}
PROCEDURE BOUTON1E(Hor1,Ver1,Hor2,Ver2 : Integer; CoulBouton : Word);

BEGIN
      SetFillStyle(1,CoulBouton);
      Bar(Hor1,Ver1,Hor2,Ver2);
      SetLineStyle(0,1,1);
      SetColor(15);
      Rectangle(Hor1,Ver1,Hor2,Ver2);
      SetColor(Black);
      Line(Hor1,Ver1,Hor2,Ver1);
      Line(Hor1,Ver1,Hor1,Ver2+1);

END;

{**************************************************************************}
PROCEDURE FENETRE4(X1F,Y1F,X2F,Y2F : Integer; CoulFond_F,CoulBouTitre_F,
                                         CoulBoutons_F,CoulBordure_F,Motif_B : Word;
                                         Bordure_F : Integer);

BEGIN
      Bouton1S_M(X1F-Bordure_F,Y1F-Bordure_F,
               X2F+Bordure_F,Y2F+Bordure_F,CoulBordure_F,Motif_B);       {Bordure}

      Bouton1E(X1F,Y1F,X2F,Y2F,CoulFond_F);                  {Fond de fentre}
      SetLineStyle(0,0,1);


      SetColor(0);                                               {Bouton de fermeture}
      Rectangle(X1F,Y1F,X1F+26,Y1F+25);
      Bouton1S(X1F+1,Y1F+1,X1F+24,Y1F+23,CoulBoutons_F);
        SetColor(0);
         Rectangle(X1F+7,Y1F+10,X1F+18,Y1F+12);
          Rectangle(X1F+6,Y1F+9,X1F+19,Y1F+13);

      SetColor(0);                                               {Bouton d'agrandissement}
      Rectangle(X2F-26,Y1F-1,X2F,Y1F+26);
      Bouton1S(X2F-25,Y1F+1,X2F-1,Y1F+24,CoulBoutons_f);
        SetColor(0);
         OutTextXY(X2F-16,Y1F+7,Chr(30));
          OutTextXY(X2F-16,Y1F+14,Chr(31));

      SetColor(0);                                               {Bouton de rduction}
      Rectangle(X2F-51,Y1F-1,X2F-25,Y1F+26);
      Bouton1S(X2F-50,Y1F+1,X2F-26,Y1F+24,CoulBoutons_F);
       SetColor(0);
       OutTextXY(X2F-41,Y1F+10,Chr(31));

      Bouton1E(X1F+32,Y1F+2,X2F-57,Y1F+23,CoulBouTitre_F);   {Bouton titre fentre}

      SetColor(CoulBordure_F);                                   {Bordure}
      Rectangle(X1F-1,Y1F-1,X2F+1,Y2F+1);
      Line(X1F,Y1F+26,X2F,Y1F+26);

END;

{**************************************************************************}
PROCEDURE PRESENTATION;

BEGIN

     SetFillPattern(Motif1,3);
      Bar(0,0,640,450);
       Fenetre4(20,20,620,430,3,3,7,12,4,7);
        SetColor(14);
         SetTextStyle(GothicFont,0,1);
          OutTextXY(205,18,'Schma d''un Turboracteur');
           SetTextStyle(0,0,0);
       Bouton1E(50,70,590,320,7);
      SetColor(10);
      SetLineStyle(2,0,1); Line(50,190,590,190);
      SetColor(1);
      SetLineStyle(1,0,1);Line(70,155,100,155); Line(70,225,100,225);
      SetLineStyle(0,0,1);Line(100,155,200,130);Line(100,225,200,250);
      Line(200,130,300,130);Line(200,250,300,250);
      Line(200,140,200,240);Line(300,130,300,250);
      Line(200,140,300,170);Line(200,240,300,210);
      Line(300,130,375,130);Line(300,250,375,250);Line(375,130,375,250);
      Line(375,130,475,130);Line(375,250,475,250);Line(475,130,475,250);
      Line(375,150,475,130);Line(375,230,475,250);
      Line(475,130,560,170);Line(475,250,560,220);
      Line(475,170,535,190);Line(475,210,535,190);


      Bouton1E(70,340,570,420,5);
      SetColor(14);
      OutTextXY(80,350,'(a)-(1) : Prise d''air');
      OutTextXY(80,375,'(1)-(2) : Diffuseur');
      OutTextXY(80,400,'(2)-(3) : Compresseur');
      OutTextXY(310,350,'(3)-(4) : Chambre de combustion');
      OutTextXY(310,375,'(4)-(5) : Turbine');
      OutTextXY(310,400,'(5)-(6) : Tuyre d''jection');
END;

{***************************************************************************}
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
                          {*** PROGRAMME PRINCIPAL ***}
BEGIN
     INITIALISATION_CARTE_GRAPHIQUE('C:\TP7\BGI');
     Presentation;
     ReadLn;
     CloseGraph;
END.


