PROGRAM L_Bouton2;                            { 21/03/94 }
                                     { Table des Mthodes Virtuelles }

USES
    Crt , Graph;
{============================ CLASSES ======================================}

TYPE
    Point = OBJECT
                  X, Y    : Integer;     { position du point }
                  CoulP   : Byte;        { couleur du point }
                  CoulF   : Byte;        { couleur du Fond }

                  CONSTRUCTOR Init (InitX, InitY : Integer);
                  PROCEDURE SetCouleur (Couleur, CoulFond : Byte);
                  PROCEDURE Affiche; Virtual;
                  PROCEDURE Cache;   Virtual;
                  PROCEDURE SetPosition (NouvoX, NouvoY : Integer);
                  PROCEDURE GetInfo (AncX, AncY : Integer; AncCoul,AncCoulF : Byte);
            End;

    P_Bouton = OBJECT ( Point )
                    X1, Y1, X2, Y2  : Integer;

                  CONSTRUCTOR Init (InitX1, InitY1, InitX2, InitY2 : Integer);
                  PROCEDURE Affiche; Virtual;
                  PROCEDURE Cache ;  Virtual;
                  PROCEDURE SetPosition (NouvoX, NouvoY, NouvoX2, NouvoY2 : Integer);
                  PROCEDURE SetTexte(Xt1,Yt1,Xt2,Yt2 : Integer; Texte : String; CoulT : Byte);
                  PROCEDURE GetInfo (AncX, AncY, AncX2, AncY2  : Integer; AncCoul : Byte);
            End;

                        {*****  Objet Point *****}
{===========================================================================}
CONSTRUCTOR Point.Init (InitX, InitY : Integer);

Begin
     X := InitX;
     Y := InitY;

           If X < 1    Then  X := 1;
           If X > 600  Then  X := 600;
           If Y < 1    Then  Y := 1;
           If Y > 400  Then  Y := 400;
End;

{===========================================================================}
PROCEDURE Point.SetCouleur (Couleur, CoulFond : Byte);

Begin
     CoulP  := Couleur;
     CoulF  := CoulFond;
End;

{===========================================================================}
PROCEDURE Point.Affiche;

Begin
     SetColor(CoulP);
     PutPixel (X,Y,GetColor);
End;

{===========================================================================}
PROCEDURE Point.Cache;

Begin
     PutPixel (X,Y,GetBkColor);
End;

{===========================================================================}
PROCEDURE Point.SetPosition (NouvoX, NouvoY : Integer);

Begin
           X := NouvoX;
           Y := NouvoY;

           If X < 1    Then  X := 1;
           If X > 600  Then  X := 600;
           If Y < 1    Then  Y := 1;
           If Y > 400  Then  Y := 400;
End;

{===========================================================================}
PROCEDURE Point.GetInfo (AncX, AncY : Integer; AncCoul, AncCoulF : Byte);

Begin
     AncX     := X ;
     AncY     := Y;
     AncCoul  := CoulP;
     AncCoulF := CoulF;
End;

{===========================================================================}
                      {*****  Objet Petit_Bouton *****}
{**************************************************************************}
CONSTRUCTOR P_Bouton.Init (InitX1, InitY1, InitX2, InitY2 : Integer);

Begin
     X1 := InitX1;
     Y1 := InitY1;
     X2 := InitX2;
     Y2 := InitY2;
End;

{**************************************************************************}
PROCEDURE P_Bouton.Affiche;

Begin
      SetBkColor(CoulF);
      SetFillStyle(1,CoulP);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,1);
      SetColor(8);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(White);
      Line(X1,Y1,X2,Y1);
      Line(X1,Y1,X1,Y2-1);

End;

{***************************************************************************}
PROCEDURE P_Bouton_Entrant;

Begin
    {  SetBkColor(CoulF);
      SetFillStyle(1,CoulP);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,1);
      SetColor(15);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(0);
      Line(X1,Y1,X2,Y1);
      Line(X1,Y1,X1,Y2+1);}

End;

{***************************************************************************}
PROCEDURE P_Bouton.Cache;
{Var
    AncX, AncY, AncX2, AncY2 : Integer;
    AncCoul                  : Byte;      }
Begin
(*     GetInfo (AncX, AncY, AncX2, AncY2, AncCoul);  *)

      SetFillStyle(1,CoulF);      { couleur du bouton }
      Bar(X,Y,X2,Y2);
      SetLineStyle(0,1,1);
      SetColor(CoulF);
      Rectangle(X,Y,X2,Y2);
      SetColor(CoulF);
      Line(X1,Y1,X2,Y1);
      Line(X1,Y1,X1,Y2-1);

End;

{***************************************************************************}
PROCEDURE P_Bouton.SetPosition (NouvoX,NouvoY,NouvoX2,NouvoY2 : Integer);

Begin
           X1  :=  NouvoX;
           Y1  :=  NouvoY;
           X2  :=  NouvoX2;
           Y2  :=  NouvoY2;
End;

{***************************************************************************}
PROCEDURE P_Bouton.SetTexte(Xt1,Yt1,Xt2,Yt2 : Integer; Texte : String; CoulT : Byte);

Var  Long_Texte : Byte;

BEGIN
     SetColor(CoulT);
     Long_Texte := Length(Texte)*8 Div 2 ;
     OutTextXY((Xt1+Xt2) Div 2 - Long_Texte,
                                     (Yt2-Yt1) Div 2 + Yt1 - 3 , Texte);

END;

{===========================================================================}
PROCEDURE P_Bouton.GetInfo (AncX, AncY, AncX2, AncY2 : Integer; AncCoul : Byte);

Begin
     AncX     := X1 ;
     AncY     := Y1;
     AncX2    := X2 ;
     AncY2    := Y2;
     AncCoul  := CoulP;
End;

{===========================================================================}

{***************************************************************************}
                      {*****  Objet Grand_Bouton *****}

{***************************************************************************}
{***************************************************************************}
{**************************  Programme Principal ***************************}
VAR
   PBouton                            : P_Bouton;
   Grmode, GrPilote, CodeErreur       : Integer;
   X, Y, X1, Y1, X2, Y2               : Integer;
   CoulP                              : Byte;

CONST
     Black = 0;
     Blue  = 1;
     Green = 2;
     White = 15;

BEGIN
     GrPilote := Detect;
     InitGraph(GrPilote,GrMode,'D:\BP\BGI');
     CodeErreur := GraphResult;
     If CodeErreur <> 0 Then Begin
                                  Write('Erreur de type Graphique ');
                                  ReadLn;
                             End
     Else
    Begin
{ With PBouton Do
         Begin
              Init(0,0,0,0);
              SetCouleur (1,3);
              SetPosition (100,100,500,150);
              Affiche;
              ReadLn;
              Cache;
              ReadLn
         End;}

     PBouton.Init(0,0,0,0);
     PBouton.SetCouleur (1,3);
     PBouton.SetPosition(50,80,400,170);
     PBouton.Affiche;
     PBouton.SetTexte(50,80,400,170,'Programmation en TurboPascal',14);
     Delay(4000);
     PBouton.Cache;
     PBouton.SetCouleur (6,3);
     PBouton.SetPosition(200,200,600,300);
     PBouton.Affiche;
     Delay(4000);
     PBouton.Cache;
     ReadLn;
    End;
END.