PROGRAM Laid_Point;

USES
  Graph, Crt;

TYPE
    Emplacement = OBJECT
                         X, Y : Integer;
                         PROCEDURE Init (InitX, InitY : Integer);
                         FUNCTION AkiX : Integer;
                         FUNCTION AkiY : Integer;
                  End;

    Point = OBJECT (Emplacement)
                  Visible : Boolean;
                  PROCEDURE Init (InitX, InitY : Integer);
                  PROCEDURE Affiche;
                  PROCEDURE Cache;
                  PROCEDURE SetPosition (NouvoX, NouvoY : Integer);
                  FUNCTION EstVisible : Boolean;
            End;


                        {*****  Objet Emplacement *****}
{===========================================================================}
PROCEDURE Emplacement.Init (InitX, InitY : Integer);
Begin
     X := InitX;
     Y := InitY;
End;

{===========================================================================}
FUNCTION Emplacement.AkiX : Integer;
Begin
     AkiX := X;
End;

{===========================================================================}
FUNCTION Emplacement.AkiY : Integer;
Begin
     AkiY := Y;
End;

                      {*****  Objet Point *****}
{===========================================================================}
PROCEDURE Point.Init (InitX, InitY : Integer);
Begin
     Emplacement.Init (InitX,InitY);
     Visible := False;
End;

{===========================================================================}
PROCEDURE Point.Affiche;
Begin
     Visible := True;
     PutPixel (X,Y,GetColor);
End;

{===========================================================================}
PROCEDURE Point.Cache;
Begin
     Visible := False;
     PutPixel (X,Y,GetBkColor);
End;

{===========================================================================}
FUNCTION Point.EstVisible : Boolean;
Begin
     EstVisible := Visible;
End;

{===========================================================================}
PROCEDURE Point.SetPosition (NouvoX,NouvoY : Integer);
Begin
     Cache;
     X := NouvoX;
     Y := NouvoY;
     Affiche;
End;

{===========================================================================}
{**************************  Programme Principal ***************************}
VAR
   Pnt : Point;
   Grmode, GrPilote,CodeErreur : Integer;
   InitX, InitY, NouvoX, NouvoY, X, Y : Integer;
   Rayon : Integer;

BEGIN
     GrPilote := Detect;
     InitGraph(GrPilote,GrMode,'D:\BP\BGI');
     CodeErreur := GraphResult;
     If CodeErreur <> 0 Then Begin
                                  Write('Erreur de type Graphique ');
                                  ReadLn;
                             End
     Else
     SetColor(14);
     InitX := 300;
     InitY := 150;
     Rayon := 150;
     Pnt.SetPosition(InitX,InitY+Rayon);
     Pnt.Affiche;
     ReadLn;
     For Y := -Rayon To Rayon Do
     Begin
          If (Y >= 0) And (Y < InitY) Then
             Begin
                  NouvoX := InitX + Round(Sqrt(Abs(Rayon*Rayon-Y*Y)));
                  NouvoY := InitY - Y;
             End;
          If (Y >= 0) And (Y > InitY) Then
             Begin
                  NouvoX := InitX + Round(Sqrt(Abs(Rayon*Rayon-Y*Y)));
                  NouvoY := InitY + Y;
             End;
          If (Y < 0) And (Abs(Y) < InitY) Then
             Begin
                  NouvoX := InitX - Round(Sqrt(Abs(Rayon*Rayon-Y*Y)));
                  NouvoY := InitY - Y;
             End;
          If (Y < 0) And (Abs(Y) > InitY) Then
             Begin
                  NouvoX := InitX - Round(Sqrt(Abs(Rayon*Rayon-Y*Y)));
                  NouvoY := InitY + Y;
             End;

          Pnt.SetPosition(NouvoX,NouvoY);
          Pnt.Affiche;
          Delay(15);
          Pnt.Cache;
     End;
     ReadLn;

END.