PROGRAM ROSA2;                       { 22/12/93 par: Lad MESSAOUDI
                    Gestionnaire de fichier pour le collge Rosa Luxembourg }

{$M 16384,0,97536}

USES
      Dos,Crt,Graph;



CONST

    Entree      = #13;
    FlecheHaut  = #72;
    FlecheBas   = #80;
    PageBas     = #81;
    F10         = #68;
    CtrlEnd     = #117;

VAR
      GraphPilot,GraphMode : Integer;

      x1,y1,x2,y2,i,Choi,NbEssais : Integer;

      Touche : Char;

      Commande    : String;
      NomFichier  : String[15];
      NouvNomFich : String[15];
      Chemin      : String[20];

      Rep : Char;

      Erreur,CodeES : Integer;

      Touch : Char;

      Repertoire : String;

      k,h     : Integer;
      LstFile : Text;
      Name    : Array[1..96] Of String[12];
      Nom     : String;
      Nbre_Fichiers,Nbre_Colonnes : Integer;
      Debut, Fin : Integer;

      PROCEDURE INITIALISATION_CARTE_GRAPHIQUE; FORWARD;
      PROCEDURE FOND_MENU;                      FORWARD;
      PROCEDURE MENU;                           FORWARD;
      PROCEDURE CHOIX;                          FORWARD;

{**************************************************************************}
PROCEDURE TOUCHE_ENTREE;

BEGIN
     Repeat
            Touche := ReadKey;
     Until Touche = Entree;
END;

{**************************************************************************}
PROCEDURE EXECUTE(Commande : String);

BEGIN
     SwapVectors;
                 Exec(GetEnv('ComSpec'), '/C' + Commande);
     SwapVectors;

END;



{**************************************************************************}
PROCEDURE FOND_ECRAN;

VAR
    i,j : Byte;

BEGIN
      ClrScr;
      TextBackGround(5);
      ClrScr;
      TextColor(White);
      GotoXY(2,1);
      Write(Chr(218));
      For i:=2 To 77 Do
             Write(Chr(196));
             Write(Chr(191));
             GoToXY(2,24);
             Write(Chr(192));
      For i:=3 To 78 Do
              Write(Chr(196));
              Write(Chr(217));
      For j:=2 To 23 Do
          Begin
              GoToXY(2,j);
                Write(Chr(179));
              GoToXY(79,j);
                Write(Chr(179));
          End;

       TextColor(1);                             { deuxime fond }
       For j:=2 To 23 Do
         Begin
           GoToXY(4,j);
                   For i:=1 To 74 Do
                   Begin
                        Write(Chr(219));
                   End;
         End;

END;



{**************************************************************************}
PROCEDURE EFFACE_COLONNES;

BEGIN
     For i:=1 To 13 Do
         Begin
              GoToXY(7,i+10);
              Write('                                                                  ');
         End;
END;
{**************************************************************************}
PROCEDURE COLONNE_1( X : Integer);

BEGIN
      TextColor(15);

       k := 7;

       If x = 1 Then  Begin
                           h     := 9;
                           Debut := 1;
                           Fin   := 6;
                      End;
       If x = 2 Then  Begin
                           h     := -39;
                           Debut :=  25;
                           Fin   :=  30;
                      End;
       If x = 3 Then  Begin
                           h     := -87;
                           Debut :=  49;
                           Fin   :=  54;
                      End;
       If x = 4 Then  Begin
                           h     := -135;
                           Debut :=  73;
                           Fin   :=  78;
                      End;
       For i:=Debut To Fin Do
                           Begin
                                 If Nbre_Fichiers >= i Then
                                      Begin
                                           GoToXY(k,2*i+h);
                                           Write(Name[i]);
                                      End;
                           End;
END;

{**************************************************************************}
PROCEDURE COLONNE_2( Y : Integer);

BEGIN
      k := k + 18;

       If y = 1 Then  Begin
                           h := h - 12;
                           Debut := 7;
                           Fin   := 12;
                      End;
       If y = 2 Then  Begin
                           h     :=  -51;
                           Debut :=   31;
                           Fin   :=   36;
                      End;
       If y = 3 Then  Begin
                           h     := -99;
                           Debut :=  55;
                           Fin   :=  60;
                      End;
       If y = 4 Then  Begin
                           h     := -147;
                           Debut :=  79;
                           Fin   :=  84;
                      End;
       For i:=Debut To Fin Do
                           Begin
                                If Nbre_Fichiers >= i Then
                                      Begin
                                           GoToXY(k,2*i+h);
                                           Write(Name[i]);
                                      End;
                           End;

END;
{**************************************************************************}
PROCEDURE COLONNE_3( Z : Integer);

BEGIN
      k := k + 18;

       If z = 1 Then  Begin
                           h := h - 12;
                           Debut := 13;
                           Fin   := 18;
                      End;
       If z = 2 Then  Begin
                           h     := -63;
                           Debut :=  37;
                           Fin   :=  42;
                      End;
       If z = 3 Then  Begin
                           h     := -111;
                           Debut :=  61;
                           Fin   :=  66;
                      End;
       If z = 4 Then  Begin
                           h     := -159;
                           Debut :=  85;
                           Fin   :=  90;
                      End;
       For i:=Debut To Fin Do
                           Begin
                                If Nbre_Fichiers >= i Then
                                      Begin
                                           GoToXY(k,2*i+h);
                                           Write(Name[i]);
                                      End;
                           End;

END;
{**************************************************************************}
PROCEDURE COLONNE_4( T : Integer);

BEGIN
      k := k + 18;

       If t = 1 Then  Begin
                           h := h - 12;
                           Debut := 19;
                           Fin   := 24;
                      End;
       If t = 2 Then  Begin
                           h     := -75;
                           Debut :=  43;
                           Fin   :=  48;
                      End;
       If t = 3 Then  Begin
                           h     := -123;
                           Debut :=  67;
                           Fin   :=  72;
                      End;
       If t = 4 Then  Begin
                           h     := -171;
                           Debut :=  91;
                           Fin   :=  96;
                      End;

       For i:=Debut To Fin Do
                           Begin
                                If Nbre_Fichiers >= i Then
                                      Begin
                                           GoToXY(k,2*i+h);
                                           Write(Name[i]);
                                      End;
                           End;

END;

{**************************************************************************}
PROCEDURE LISTE_FICHIERS;

BEGIN

      Execute('Dir /b /a:-d /o:n >Liste');
      Nbre_Fichiers := 0;


      Assign(LstFile,'Liste');
      Reset(LstFile);
        While Not EOF(LstFile) Do
              Begin
                    ReadLn(LstFile,Nom);
                    Nbre_Fichiers := Nbre_Fichiers + 1;
                    Name[Nbre_Fichiers] := Nom;
              End;

       Nbre_Colonnes := Trunc(Nbre_Fichiers/6);
       If Frac(Nbre_Fichiers/6) >= 0.1 Then
                                     Nbre_Colonnes := Nbre_Colonnes + 1;


       Case Nbre_Colonnes Of

     1,2,3,4    : Begin
                       Colonne_1(1);
                       Colonne_2(1);
                       Colonne_3(1);
                       Colonne_4(1);
                  End;
     5,6,7,8    : Begin
                       Colonne_1(1);
                       Colonne_2(1);
                       Colonne_3(1);
                       Colonne_4(1);

                       GoToXY(25,23);
                         TextColor(13);
                           WriteLn('Suite de la liste ===>> PgDn');

                       Touche := ReadKey;
                       If Touche = #0 Then
                          Begin
                               Touche := ReadKey;
                               If Touche = PageBas Then
                                  Begin
                                       Efface_Colonnes;
                                       Colonne_1(2);
                                       Colonne_2(2);
                                       Colonne_3(2);
                                       Colonne_4(2);
                                  End;

                          End;
                  End;

     9,10,11,12 : Begin
                       Colonne_1(1);
                       Colonne_2(1);
                       Colonne_3(1);
                       Colonne_4(1);

                       GoToXY(25,23);
                         TextColor(13);
                           WriteLn('Suite de la liste ===>> PgDn');

                       Touche := ReadKey;
                       If Touche = #0 Then
                          Begin
                               Touche := ReadKey;
                               If Touche = PageBas Then
                                  Begin
                                       Efface_Colonnes;
                                       Colonne_1(2);
                                       Colonne_2(2);
                                       Colonne_3(2);
                                       Colonne_4(2);
                                  End;
                          End;

                        GoToXY(25,23);
                         TextColor(13);
                           WriteLn('Suite de la liste ===>> PgDn');

                        Touche := ReadKey;
                        If Touche = #0 Then
                           Begin
                                Touche := ReadKey;
                                If Touche = PageBas Then
                                   Begin
                                        Efface_Colonnes;
                                        Colonne_1(3);
                                        Colonne_2(3);
                                        Colonne_3(3);
                                        Colonne_4(3);
                                   End;
                           End;
                  End;

     13,14,15,16: Begin
                       Colonne_1(1);
                       Colonne_2(1);
                       Colonne_3(1);
                       Colonne_4(1);

                       GoToXY(25,23);
                         TextColor(13);
                           WriteLn('Suite de la liste ===>> PgDn');

                       Touche := ReadKey;
                       If Touche = #0 Then
                          Begin
                               Touche := ReadKey;
                               If Touche = PageBas Then
                                  Begin
                                       Efface_Colonnes;
                                       Colonne_1(2);
                                       Colonne_2(2);
                                       Colonne_3(2);
                                       Colonne_4(2);
                                  End;
                          End;

                        GoToXY(25,23);
                         TextColor(13);
                           WriteLn('Suite de la liste ===>> PgDn');

                        Touche := ReadKey;
                        If Touche = #0 Then
                           Begin
                                Touche := ReadKey;
                                If Touche = PageBas Then
                                   Begin
                                        Efface_Colonnes;
                                        Colonne_1(3);
                                        Colonne_2(3);
                                        Colonne_3(3);
                                        Colonne_4(3);
                                   End;
                           End;

                           Touche := ReadKey;
                           If Touche = #0 Then
                              Begin
                                   Touche := ReadKey;
                                   If Touche = PageBas Then
                                      Begin
                                           Efface_Colonnes;
                                           Colonne_1(4);
                                           Colonne_2(4);
                                           Colonne_3(4);
                                           Colonne_4(4);
                                      End;
                              End;
                  End;
     End;
END;
{**************************************************************************}
PROCEDURE CONTROLE_FICHIER;

VAR

   Repert : Text;
   Chemin_Fichier : String;

BEGIN
     NbEssais := 0;
     GetDir(0,Repertoire);

     Repeat

     GoToXY(25,23);
        TextColor(13);
           WriteLn('Liste des Fichiers ===>> F10');

     Touche := ReadKey;
     If Touche = #0 Then
               Begin
                    Touche := ReadKey;
                    If Touche = F10 Then
                              Begin
                                   GoToXY(25,23);
                                    Write('                               ');
                                     Liste_Fichiers;
                              End;
               End;

           TextColor(12);
             GoToXY(48,7);
               ReadLn(NomFichier);

       Efface_Colonnes;

       Chemin_Fichier := Repertoire + '\' + NomFichier;
       {$I-};
       Assign(Repert,Chemin_Fichier);
       Reset(Repert);
       Close(Repert);
       {$I+};
       CodeES := IOResult;
       If CodeES <> 0  Then
          Begin
               NbEssais := NbEssais + 1;
               GoToXY(5,9);
               TextColor(LightGreen+Blink);
               Write(Chr(7));
               Write('  Ce fichier n''existe pas. Frappez sur ENTREE ');

               Touche_Entree;

               If NbEssais = 2 Then
                           Begin
                                INITIALISATION_CARTE_GRAPHIQUE;
                                 FOND_MENU;
                                  MENU;
                                   CHOIX;
                                    CloseGraph;
                                Halt(1);
                           End
               Else
               GoToXY(5,9);
               Write('                                               ');
               GoToXY(46,7);
               Write('                                ');

          End;
     Until CodeES = 0 ;

END;
{**************************************************************************}
PROCEDURE CONTROLE_CHEMIN;

BEGIN

     NbEssais := 0;
     Repeat
           GoToXY(39,13);
             TextColor(12);
               ReadLn(Chemin);
        {$I-};
       ChDir(Chemin);                 { vrification du chemin }
        {$I+};
       CodeES := IOResult;
       If CodeES <> 0  Then
          Begin
               NbEssais := NbEssais + 1;
               GoToXY(5,16);
               TextColor(LightGreen+Blink);
               Write(Chr(7));
               Write('  Chemin introuvable. Frappez sur ENTREE ');
               ReadLn;

               If NbEssais = 2 Then
                           Begin
                                INITIALISATION_CARTE_GRAPHIQUE;
                                 FOND_MENU;
                                  MENU;
                                   CHOIX;
                                    CloseGraph;
                                Halt(1);
                           End
               Else
               GoToXY(39,13);
               Write('                            ');
               GoToXY(5,16);
               Write('                                          ');
          End;

     Until CodeES = 0 ;

END;

{**************************************************************************}
PROCEDURE DOS_ERROR;

BEGIN
          TextColor(12);
          GoToXY(5,16);
          Write ('Impossible d''excuter Commande.com');
          TextColor(Green);
          GoToXY(7,20);
          Write('Frapper sur la touche ENTREE');

          Touche_Entree;
END;




{**************************************************************************}
PROCEDURE VOIR;

BEGIN
     FOND_ECRAN;
      TextBackGround(1);
       TextColor(14);
        GoToXY(5,7);
         Write('  Donner le nom du fichier  visualiser :  ');
         
     Controle_Fichier;

     TextColor(3);
     TextBackGround(Black);
      ClrScr;


             Execute('Type '+ NomFichier+' |more');

             ReadLn;
             TextColor(Green);
             WriteLn;Write('Frapper sur la touche ENTREE');

             Touche_Entree;

     If DosError <> 0 Then
        Begin
             DOS_ERROR;
        End;

End;

{***************************************************************************}
PROCEDURE SUPRIME;

BEGIN
     FOND_ECRAN;
      TextBackGround(1);
       TextColor(14);
        GoToXY(5,7);
         Write('  Donner le nom du fichier  supprimer  :  ');
     Controle_Fichier;

             TextBackGround(Black);
              ClrScr;

             Execute('Del '+ NomFichier);

             TextColor(Green);
              WriteLn;Write('Fichier supprim ! Frapper sur la touche ENTREE');

              Touche_Entree;

     If DosError <> 0 Then
         Begin
              DOS_ERROR;
         End;
END;

{**************************************************************************}
PROCEDURE MODIF;

BEGIN
     FOND_ECRAN;
      TextBackGround(1);
       TextColor(14);
        GoToXY(5,7);
         Write('  Donner le nom du fichier  Modifier   :  ');
     Controle_Fichier;

             TextBackground(Black);
              ClrScr;

             Execute('Edlin '+ NomFichier);

             TextColor(Green);
              WriteLn;Write('Frapper sur la touche ENTREE');

              Touche_Entree;

     If DosError <> 0 Then
         Begin
              DOS_ERROR;
         End;
END;

{**************************************************************************}
PROCEDURE DISK_COPIE;

BEGIN
     TextColor(14);
      GoToXY(5,13);
       Write('  Tapez le chemin de sauvegarde : ');

     Controle_Chemin;

     ChDir(Repertoire);                 { revient au rpertoire initial }


     TextBackGround(Black);
      ClrScr;

           Execute('Copy '+ NomFichier + 'to '+ Chemin);

     If DosError <> 0 Then DOS_ERROR;
          TextColor(Green);
          WriteLn;Write('Frapper sur la touche ENTREE');

          Touche_Entree;
END;

{***********************************************************************}
PROCEDURE COPIE;

BEGIN
     FOND_ECRAN;
      TextBackGround(1);
       GoToXY(43,7);
        Write('                    ');
     TextColor(14);
      GoToXY(5,7);
       Write('  Donner le nom du fichier  copier   :  ');

     Controle_Fichier;

     Disk_Copie;

END;

{**************************************************************************}
PROCEDURE RENOME;

BEGIN
     FOND_ECRAN;
      TextBackGround(1);
       TextColor(14);
        GoToXY(5,7);
         Write('  Donner le nom du fichier  Modifier   :  ');
     Controle_Fichier;

     TextColor(14);
       GoToXY(5,12);
         Write('  Donner le nom du nouveau fichier  :  ');
           TextColor(12);
             ReadLn(NouvNomFich);

             TextBackground(Black);
              ClrScr;

             Execute('Rename '+ NomFichier + ' ' + NouvNomFich);

             TextColor(Green);
              WriteLn;Write('Frapper sur la touche ENTREE');

              Touche_Entree;

     If DosError <> 0 Then
         Begin
              DOS_ERROR;
         End;
END;

{**************************************************************************}

{**************************************************************************}
{------------------ *** MENU GRAPHIQUE ***  -------------------------------}
{**************************************************************************}
PROCEDURE INITIALISATION_CARTE_GRAPHIQUE;

BEGIN
       GraphPilot:=Detect;
       InitGraph(GraphPilot,GraphMode,'C:\TP7\BGI');
       If GraphResult <> GrOk Then
       Halt(1);
END;

{***************************************************************************}
PROCEDURE BOUTON1S(Hor1,Ver1,Hor2,Ver2 : Integer; CoulBouton : Word);

BEGIN
      SetFillStyle(1,CoulBouton);
      Bar(Hor1,Ver1,Hor2,Ver2);
      SetLineStyle(0,1,1);
      SetColor(Black);
      Rectangle(Hor1,Ver1,Hor2,Ver2);

      SetColor(15);
      Line(Hor1,Ver1,Hor2,Ver1);
      Line(Hor1,Ver1,Hor1,Ver2-1);

END;

{***************************************************************************}
PROCEDURE BOUTON1E(Hor1,Ver1,Hor2,Ver2 : Integer; CoulBouton : Word);

BEGIN
      SetFillStyle(1,CoulBouton);
      Bar(Hor1,Ver1,Hor2,Ver2);
      SetLineStyle(0,1,1);
      SetColor(15);
      Rectangle(Hor1,Ver1,Hor2,Ver2);
      SetColor(Black);
      Line(Hor1,Ver1,Hor2,Ver1);
      Line(Hor1,Ver1,Hor1,Ver2+1);

END;

{***************************************************************************}
PROCEDURE BOUTON2S(Hor1,Ver1,Hor2,Ver2 : Integer; CoulBouton : Word);

BEGIN
      SetFillStyle(1,CoulBouton);
      Bar(Hor1,Ver1,Hor2,Ver2);
      SetLineStyle(0,1,3);
      SetColor(Black);
      Rectangle(Hor1,Ver1,Hor2,Ver2);

      SetColor(15);
      SetLineStyle(0,1,1);
      Line(Hor1,Ver1-1,Hor2,Ver1-1);
      Line(Hor1,Ver1,Hor2-1,Ver1);
      Line(Hor1,Ver1+1,Hor2-2,Ver1+1);

      Line(Hor1-1,Ver1,Hor1-1,Ver2);
      Line(Hor1,Ver1,Hor1,Ver2-1);
      Line(Hor1+1,Ver1,Hor1+1,Ver2-2);

END;

{***************************************************************************}
PROCEDURE BOUTON2E(Hor1,Ver1,Hor2,Ver2 : Integer; CoulBouton : Word);

BEGIN
      SetFillStyle(1,CoulBouton);
      Bar(Hor1,Ver1,Hor2,Ver2);
      SetLineStyle(0,1,3);
      SetColor(15);
      Rectangle(Hor1,Ver1,Hor2,Ver2);

      SetColor(Black);
      SetLineStyle(0,1,1);
      Line(Hor1,Ver1-1,Hor2,Ver1-1);
      Line(Hor1,Ver1,Hor2-1,Ver1);
      Line(Hor1,Ver1+1,Hor2-2,Ver1+1);

      Line(Hor1-1,Ver1,Hor1-1,Ver2);
      Line(Hor1,Ver1,Hor1,Ver2-1);
      Line(Hor1+1,Ver1,Hor1+1,Ver2-2);

END;

{***************************************************************************}
PROCEDURE FOND_MENU;

BEGIN

      SetFillStyle(8,4);
       Bar(0,0,650,450);
        SetLineStyle(0,1,3);
         Rectangle(20-5,20-5,600+15,420+5);
         SetColor(9);
        SetTextStyle(0,0,1);
       SetFillStyle(1,3);
      Bar(20,20,610,420);

END;

{***************************************************************************}
PROCEDURE MENU;

BEGIN
       Bouton1S(21,26,164,271,13);
       Bouton1E(25,30,160,267,1);
       SetColor(1);
      SetTextStyle(0,0,0);
     OutTextxy(57,42,'Collge');
     SetColor(White);
      SetTextStyle(0,0,0);
       OutTextxy(55,65,'Programme ');
        OutTextxy(78,90,'de ');
         OutTextxy(58,115,'gestion ');
          OutTextxy(75,140,'des ');
           OutTextxy(58,165,'fichiers ');
            OutTextxy(32,190,'par: ');
     SetColor(LightGreen);
      OutTextxy(72,190,'MESSAOUDI ');
       OutTextxy(73,215,'Lad');
     SetColor(1);
      OutTextxy(35,245,'Rosa Luxembourg');
     SetColor(12);
      OutTextxy(35,245,'CopyWrite 1993');

      SetColor(12);
       Rectangle(188,24,467,61);
       Bouton2E(190,26,465,59,0);
        SetTextStyle(1,0,0);
        SetColor(15);
         OutTextxy(150,22,'   MENU PRINCIPAL');
          SetTextStyle(0,0,1);

      SetViewPort(30,100,600,420,false);

  Begin
       x1:=145; y1:=-5; x2:=440; y2:=15;

       For i:=1 to 7 Do
           Begin
                  Bouton1S(x1-2,y1-2,x2+2,y2+2,7);
                  Bouton1S(x1,y1,x2,y2,7);
                  x1:=x1+15; y1:=y1+30;x2:=x2-15; y2:=y2+30;
           End;

     SetColor(black);
      OutTextxy(205,1,'Visualiser un fichier ');
       OutTextxy(205,30,'Supprimer un fichier ');
        OutTextxy(210,60,'Modifier un fichier   ');
         OutTextxy(220,90,'Copier un fichier ');
          OutTextxy(227,122,'Renomer un fichier ');
           OutTextxy(265,152,'Sortie ');
            OutTextxy(275,182,'Aide ');

     SetLineStyle(0,1,3);
     Bouton1S(398,291,574,314,7);
      Bouton1S(400,293,572,312,7);
       SetColor(6);
        OutTextxy(405,299,' RETURN pour valider');

      Bouton1S(-2,291,217,314,7);
      Bouton1S(0,293,215,312,7);
      SetColor(6);
        OutTextxy(4,299,' Dplacement pour choisir');
  End;

END;
{**********************************************************************}
PROCEDURE ECRI_TITRES;

BEGIN
     SetColor(black);
       OutTextxy(205,1,'Visualiser un fichier ');
        OutTextxy(205,30,'Supprimer un fichier ');
         OutTextxy(210,60,'Modifier un fichier   ');
          OutTextxy(220,90,'Copier un fichier ');
           OutTextxy(227,122,'Renomer un fichier ');
            OutTextxy(265,152,'Sortie ');
             OutTextxy(275,182,'Aide ');
END;

{**********************************************************************}
PROCEDURE ECRIT_TITRES(Choi : Integer);

BEGIN
     SetColor(black);
     Case Choi Of
      1 : Begin
               OutTextxy(205,1,'Visualiser un fichier ');
               OutTextxy(205,30,'Supprimer un fichier ');
               OutTextxy(275,182,'Aide ');
          End;

      2 : Begin
               OutTextxy(205,1,'Visualiser un fichier ');
               OutTextxy(205,30,'Supprimer un fichier ');
               OutTextxy(210,60,'Modifier un fichier   ');
          End;

      3 : Begin
               OutTextxy(205,30,'Supprimer un fichier ');
               OutTextxy(210,60,'Modifier un fichier   ');
               OutTextxy(220,90,'Copier un fichier ');
          End;

      4 : Begin
               OutTextxy(210,60,'Modifier un fichier   ');
               OutTextxy(220,90,'Copier un fichier ');
               OutTextxy(227,122,'Renomer un fichier ');
          End;

      5 : Begin
               OutTextxy(220,90,'Copier un fichier ');
               OutTextxy(227,122,'Renomer un fichier ');
               OutTextxy(265,152,'Sortie ');
          End;

      6 : Begin
               OutTextxy(227,122,'Renomer un fichier ');
               OutTextxy(265,152,'Sortie ');
               OutTextxy(275,182,'Aide ');
          End;

      7 : Begin
               OutTextxy(205,1,'Visualiser un fichier ');
               OutTextxy(265,152,'Sortie ');
               OutTextxy(275,182,'Aide ');
          End;
     End;
END;

{**********************************************************************}
PROCEDURE FOND_AIDE;

BEGIN
     FOND_MENU;
      SetLineStyle(0,0,1);
      SetColor(12);
      Rectangle(233,24,330,61);
       Bouton2E(235,26,328,59,0);
        SetTextStyle(1,0,0);
        SetColor(15);
         OutTextxy(200,22,'   AIDE');
          SetTextStyle(0,0,1);
END;

{***********************************************************************}
PROCEDURE AIDE;

BEGIN

      SetColor(15);
      FOND_AIDE;
     {  Bouton1S(535,38,603,57,3);
       OutTextxy(540,45,' Page 1');}

      SetColor(Black);
      OutTextxy(40,85,'- L''utilisation du programme est globalement assez simple.');
      OutTextxy(40,100,'  Pour le lancer taper ROSA dans n''importe quel rpertoire.');
      OutTextxy(40,140,'- Une certaine difficult se pose au niveau de la modification des');
      OutTextxy(40,155,'  fichiers pour ceux qui ne sont pas familiers avec EDLIN du DOS.');
      OutTextxy(40,195,'- Pour modifier un fichier il suffit de taper le N de la ligne');
      OutTextxy(40,210,'  juste aprs l''toile et puis valider avec RETURN.');
      OutTextxy(40,225,'  La ligne demande sera alors affiche. Si on veut la conserver');
      OutTextxy(40,240,'  on frappe la touche F3 puis on valide. Si on veut la modifier, on');
      OutTextxy(40,255,'  crit la nouvelle ligne juste en dessous et on valide.');
      OutTextxy(40,270,'  Pour terminer il suffit de tapper END devant l''toile situe  ');
      OutTextxy(40,285,'  l''extrme gauche de l''cran.');

       Bouton1S(416,353,607,382,7);
       Bouton1S(418,355,605,380,7);
       SetColor(6);
       OutTextxy(425,365,'<< Appuyer sur PgDn >>');

             Repeat
                  Begin
                      Touche := Readkey;
                  End;
             Until (Touche=PageBas);

END;
{*************************************************************************}
PROCEDURE EFFACE (Choi : Integer) ;

BEGIN

       Case Choi Of
         1: Begin
                 x1:=145; y1:=-5; x2:=440; y2:=15;
            End;
         2: Begin
                 x1:=160; y1:=25; x2:=425; y2:=45;
            End;
         3: Begin
                 x1:=175; y1:=55; x2:=410; y2:=75;
            End;
         4: Begin
                 x1:=190; y1:=85; x2:=395; y2:=105;
            End;
         5: Begin
                 x1:=205; y1:=115; x2:=380; y2:=135;
            End;
         6: Begin
                 x1:=220; y1:=145; x2:=365; y2:=165;
            End;
         7: Begin
                 x1:=235; y1:=175; x2:=350; y2:=195;
            End;
       End;
                Line(x1,y1,x1,y2+1);
                Bouton1S(x1,y1,x2,y2,7);
END;

{**************************************************************************}
PROCEDURE CHOIX;

BEGIN
      Choi := 1;

      Bouton1E(145,-5,440,15,7);
      ECRI_TITRES;

      Repeat
            Touche:=ReadKey;
       Begin
           If Touche = FlecheBas  Then Choi := Choi+1;
           If Touche = FlecheHaut Then Choi := Choi-1;
           If Choi >=8 Then Choi := 1;
           If Choi < 1 Then Choi := 7;
       End;

      Case Choi Of
      1: Begin
              EFFACE(Choi);EFFACE(Choi+6);EFFACE(Choi+1);
              Bouton1E(145,-5,440,15,7);
              ECRIT_TITRES(Choi);
                 If touche = Entree Then
                        Begin
                             RestoreCrtMode;
                              VOIR;
                               SetGraphMode(GraphMode);
                                FOND_MENU;
                               MENU;
                               Bouton1E(145,-5,440,15,7);
                               ECRI_TITRES;
                        End;
         End;
      2: Begin
              EFFACE(Choi);EFFACE(Choi-1);EFFACE(Choi+1);
              Bouton1E(160,25,425,45,7);
              ECRIT_TITRES(Choi);
                 If Touche = Entree Then
                        Begin
                             RestoreCrtMode;
                              SUPRIME;
                               SetGraphMode(GraphMode);
                                FOND_MENU;
                               MENU;
                               Bouton1E(160,25,425,45,7);
                               ECRI_TITRES;
                        End;
         End;
      3: Begin
              EFFACE(Choi);EFFACE(Choi-1);EFFACE(Choi+1);
              Bouton1E(175,55,410,75,7);
              ECRIT_TITRES(Choi);
                 If Touche = Entree Then
                        Begin
                             RestoreCrtMode;
                              MODIF;
                               SetGraphMode(GraphMode);
                                FOND_MENU;
                               MENU;
                               Bouton1E(175,55,410,75,7);
                               ECRI_TITRES;
                        End;
         End;
      4: Begin
              EFFACE(Choi);EFFACE(Choi-1);EFFACE(Choi+1);
              Bouton1E(190,85,395,105,7);
              ECRIT_TITRES(Choi);
                 If Touche = Entree Then
                        Begin
                             RestoreCrtMode;
                              COPIE;
                               SetGraphMode(GraphMode);
                                FOND_MENU;
                               MENU;
                               Bouton1E(190,85,395,105,7);
                               ECRI_TITRES;

                        End;
         End;
      5: Begin
              EFFACE(Choi);EFFACE(Choi-1);EFFACE(Choi+1);
              Bouton1E(205,115,380,135,7);
              ECRIT_TITRES(Choi);
                 If Touche = Entree Then
                        Begin
                             RestoreCrtMode;
                              RENOME;
                               SetGraphMode(GraphMode);
                                FOND_MENU;
                               MENU;
                               Bouton1E(205,115,380,135,7);
                               ECRI_TITRES;
                        End;
         End;
      6: Begin
              EFFACE(Choi);EFFACE(Choi-1);EFFACE(Choi+1);
              Bouton1E(220,145,365,165,7);
              ECRIT_TITRES(Choi);
                 If Touche = Entree Then
                        Begin
                             CloseGraph;
                              RestoreCrtMode;
                             HALT(1);
                        End;
         End;
      7: Begin
              EFFACE(Choi);EFFACE(Choi-1);EFFACE(Choi-6);
              Bouton1E(235,175,350,195,7);
              ECRIT_TITRES(Choi);
                 If Touche = Entree Then
                        Begin
                             AIDE;
                              SetGraphMode(GraphMode);
                               FOND_MENU;
                               MENU;
                               Bouton1E(235,175,350,195,7);
                               ECRI_TITRES;
                        End;
         End;

      End;

      Until (Touche=CtrlEnd);

END;

{***************************************************************************}
{**************************************************************************}
       {-----------------* PROGRAMME PRINCIPAL *--------------------}


BEGIN
     INITIALISATION_CARTE_GRAPHIQUE;
     FOND_MENU;
     MENU;
     CHOIX;
     CloseGraph;
END.
