Program Colbrook;                     { 27/11/95 par: Lad MESSSAOUDI}

Uses    Crt;

Const   Nbr_Iter = 5;

Var     x        : Real;
        i        : Integer;

{===========================================================================}
FUNCTION F (x : Real): Real;

Begin
     F := 1 + 2*Sqrt(x)*0.43429*Ln(3.71/(1.18e6*Sqrt(x)));
     {F := x*x - 2*x + 1;}
End;

{===========================================================================}
FUNCTION DF (x : Real): Real;

Begin
     DF := (0.43429/Sqrt(x))*(Ln(3.71/(1.18e6*Sqrt(x))) - 1);
     {DF := 2*x - 2;}
End;

{===========================================================================}
PROCEDURE Newton;

Begin
     For i:=1 To Nbr_Iter Do x := x - (F(x)/DF(x));
End;

{===========================================================================}
PROCEDURE Iterative;

Begin
     For i:= 1 To Nbr_Iter Do
         Begin
              x := Sqr((1/(2*0.43429*Ln(3.71/(1.18e6*Sqrt(x))))));
         End;
End;

{========================= Programme principal =============================}
BEGIN
     ClrScr;
     x := 0.05; {valeur initiale}
     Iterative;
               WriteLn(' - Mthode itrative: ',x:3:5);
     Newton;
            WriteLn(' - Mthode de Newton: ',x:3:5);
     ReadLn;
END.