PROGRAM Mot_De_Passe;                       {30/04/94  par: Lad MESSAOUDI}

{$M 16384,0,50000}

USES
   Crt, Dos, Graph;

CONST
    Motif1 : FillPatternType = ($CC, $15, $BD,
      $15, $BC, $15, $BD, $15);
    Entree = #13;
    Vrai_Mot_Passe = 'TOTO';

VAR
   Mot_Passe                : String[15];
   VecteurB                 : Pointer;
   CheckBreak               : Boolean;
   x1,y1,x2,y2              : Integer;


{==========================================================================}
PROCEDURE INITIALISATION_CARTE_GRAPHIQUE(CheminGraph : String);

VAR
    GraphPilot, GraphMode : Integer;

BEGIN
       GraphPilot := Detect;
        InitGraph(GraphPilot,GraphMode,CheminGraph);
        If GraphResult <> GrOk Then
       Halt(1);
END;

{***************************************************************************}
PROCEDURE BOUTON1S(Hor1,Ver1,Hor2,Ver2 : Integer; CoulBouton : Word);

BEGIN
      SetFillStyle(1,CoulBouton);
      Bar(Hor1,Ver1,Hor2,Ver2);
      SetLineStyle(0,1,1);
      SetColor(Black);
      Rectangle(Hor1,Ver1,Hor2,Ver2);
      SetColor(15);
      Line(Hor1,Ver1,Hor2,Ver1);
      Line(Hor1,Ver1,Hor1,Ver2-1);

END;

{**************************************************************************}
PROCEDURE BOUTON1S_M(Hor1,Ver1,Hor2,Ver2 : Integer; CoulBouton, Motif_B : Word);

BEGIN
      SetFillStyle(Motif_B,CoulBouton);
      Bar(Hor1,Ver1,Hor2,Ver2);
      SetLineStyle(0,1,1);
      SetColor(Black);
      Rectangle(Hor1,Ver1,Hor2,Ver2);
      SetColor(15);
      Line(Hor1,Ver1,Hor2,Ver1);
      Line(Hor1,Ver1,Hor1,Ver2-1);

END;

{***************************************************************************}
PROCEDURE BOUTON1E(Hor1,Ver1,Hor2,Ver2 : Integer; CoulBouton : Word);

BEGIN
      SetFillStyle(1,CoulBouton);
      Bar(Hor1,Ver1,Hor2,Ver2);
      SetLineStyle(0,1,1);
      SetColor(15);
      Rectangle(Hor1,Ver1,Hor2,Ver2);
      SetColor(Black);
      Line(Hor1,Ver1,Hor2,Ver1);
      Line(Hor1,Ver1,Hor1,Ver2+1);

END;

{**************************************************************************}
PROCEDURE FENETRE4(X1F,Y1F,X2F,Y2F : Integer; CoulFond_F,CoulBouTitre_F,
                                         CoulBoutons_F,CoulBordure_F,Motif_B : Word;
                                         Bordure_F : Integer);

BEGIN
      Bouton1S_M(X1F-Bordure_F,Y1F-Bordure_F,
               X2F+Bordure_F,Y2F+Bordure_F,CoulBordure_F,Motif_B);       {Bordure}

      Bouton1E(X1F,Y1F,X2F,Y2F,CoulFond_F);                  	{Fond de fentre}
      SetLineStyle(0,0,1);


      SetColor(0);                                               {Bouton de fermeture}
      Rectangle(X1F,Y1F,X1F+26,Y1F+25);
      Bouton1S(X1F+1,Y1F+1,X1F+24,Y1F+23,CoulBoutons_F);
        SetColor(0);
         Rectangle(X1F+7,Y1F+10,X1F+18,Y1F+12);
          Rectangle(X1F+6,Y1F+9,X1F+19,Y1F+13);

      SetColor(0);                                               {Bouton d'agrandissement}
      Rectangle(X2F-26,Y1F-1,X2F,Y1F+26);
      Bouton1S(X2F-25,Y1F+1,X2F-1,Y1F+24,CoulBoutons_f);
        SetColor(0);
         OutTextXY(X2F-16,Y1F+7,Chr(30));
          OutTextXY(X2F-16,Y1F+14,Chr(31));

      SetColor(0);                                               {Bouton de rduction}
      Rectangle(X2F-51,Y1F-1,X2F-25,Y1F+26);
      Bouton1S(X2F-50,Y1F+1,X2F-26,Y1F+24,CoulBoutons_F);
       SetColor(0);
       OutTextXY(X2F-41,Y1F+10,Chr(31));

      Bouton1E(X1F+32,Y1F+2,X2F-57,Y1F+23,CoulBouTitre_F);   {Bouton titre fentre}

      SetColor(CoulBordure_F);                                   {Bordure}
      Rectangle(X1F-1,Y1F-1,X2F+1,Y2F+1);
      Line(X1F,Y1F+26,X2F,Y1F+26);

END;

{**************************************************************************}
PROCEDURE PRESENTATION;

BEGIN

     SetFillPattern(Motif1,3);
      Bar(0,0,640,450);
       Fenetre4(20,20,620,430,3,3,7,12,4,3);
        SetColor(14);
         SetTextStyle(GothicFont,0,1);
          OutTextXY(205,18,'Programme de protection');
           SetTextStyle(0,0,0);
       Bouton1E(420,160,545,320,7);
        SetColor(0);
         OutTextXY(425,170,'Copyright 1993');
          OutTextXY(470,200,'By');
           SetColor(1);
            OutTextXY(425,235,'MESSAOUDI Lad');
             SetColor(Red);
              SetTextStyle(GothicFont,0,1);
               OutTextXY(442,267,'Hess Mess');
                SetTextStyle(DefaultFont,0,1);
                 OutTextXY(438,298,'Association');

      Bouton1E(100,130,390,340,3);
       Bouton1S(140,170,350,300,3);
        SetColor(0);
         SetTextStyle(GothicFont,0,1);
          OutTextXY(155,187,'Donner le mot de passe');
           SetTextStyle(0,0,0);

          Bouton1S(175,230,310,270,3);
          {SetViewPort(173,228,312,272,ClipOn);}
END;

{***************************************************************************}
{$F+}
{============================================}
PROCEDURE Break;

interrupt;

Begin
     Writeln('Break');
End;
{============================================}
{$F-}

PROCEDURE Modif;

BEGIN
     GetIntVec($1B,VecteurB);
     SetIntVec($1B,Addr(Break));
END;
{===========================================================}
{***************************************************************************}
PROCEDURE CODE ;

BEGIN
      CheckBreak:=False;
      Mot_Passe := '';
      Repeat
             GoToXY(27,16);
               TextColor(0);ReadLn(Mot_Passe);

      If (Mot_Passe <> Vrai_Mot_Passe) Then
                                Begin
                                     Bouton1S(175,230,310,270,3);
                                     SetColor(14);
                                     OutTextXY(170,320,'mot de passe erron!');
                                     Code;
                                End;

      Until Mot_Passe = Vrai_Mot_Passe;
     SetIntVec($1B,VecteurB);
END;

{***************************************************************************}
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
                          {*** PROGRAMME PRINCIPAL ***}
BEGIN
     Modif;
     INITIALISATION_CARTE_GRAPHIQUE('C:\TurboPas\Graph');
     Presentation;
     Code;
     CloseGraph;
END.


