PROGRAM Objet_Fenetre;                            { 06/04/1994 par: Lad MESSAOUDI }

USES
    CRT, GRAPH, ObjBout;
{----------------------------- Classes -------------------------------------}
TYPE
   Fenetre = OBJECT
           X1f, Y1f, X2f, Y2f, EpBord_F                   :  Integer;
           CoulF_F, CoulFn_F, CoulBT_F                    :  Byte;
           CoulB_F, CoulBr_F,CoulMB_F                     : Byte;

           CONSTRUCTOR Init (InitX1f, InitY1f, InitX2f, InitY2f    :  Integer);
           PROCEDURE SetCouleur (CoulFond, CoulFen, CoulBTitre,
                                CoulBoutons, CoulBordure, CoulMotif_Bouton : Byte);
           PROCEDURE SetPosition (NouvoX1f, NouvoY1f, NouvoX2f, NouvoY2f, Ep_Bord : Integer);
           PROCEDURE SetTexte (Titre : String; CoulTitre_F : Byte);
           PROCEDURE Affiche;  Virtual;
           PROCEDURE Cache;    Virtual;


   End;
{---------------------------------------------------------------------------}
VAR
      PBoutonE                     : P_BoutonE;
      PBoutonS                     : P_BoutonS;
      Fen                          : Fenetre;

{========================== Objet Fenetre ==================================}
CONSTRUCTOR Fenetre.Init (InitX1f, InitY1f, InitX2f, InitY2f    :  Integer);

Begin
      X1f  :=  InitX1f;
      Y1f  :=  InitY1f;
      X1f  :=  InitX2f;
      Y2f  :=  InitY2f;

      If X1f < 1     Then  X1f  :=  1;
      If Y1f < 1     Then  Y1f  :=  1;
      If X2f > 640   Then  X2f  :=  640;
      If Y2f > 480   Then  Y2f  :=  480;
End;

{---------------------------------------------------------------------------}
PROCEDURE Fenetre.SetCouleur (CoulFond, CoulFen, CoulBTitre,
                             CoulBoutons, CoulBordure, CoulMotif_Bouton : Byte);

Begin
     CoulF_F   :=  CoulFond;
     CoulFn_F  :=  CoulFen;
     CoulBT_F  :=  CoulBTitre;
     CoulB_F   :=  CoulBoutons;
     CoulBr_F  :=  CoulBordure;
     CoulMB_F  :=  CoulMotif_Bouton;
End;

{---------------------------------------------------------------------------}
PROCEDURE Fenetre.SetPosition (NouvoX1f, NouvoY1f, NouvoX2f, NouvoY2f, Ep_Bord : Integer);

Begin
      X1f       :=  NouvoX1f;
      Y1f       :=  NouvoY1f;
      X2f       :=  NouvoX2f;
      Y2f       :=  NouvoY2f;
      EpBord_F  :=  Ep_Bord;
End;

{---------------------------------------------------------------------------}
PROCEDURE Fenetre.SetTexte (Titre : String; CoulTitre_F : Byte);

Var
   LongTitre  :  Byte;

Begin
     SetColor(CoulTitre_F);
     LongTitre := Length(Titre)*8 Div 2;
  {   OutTextXY((Xt}

End;

{---------------------------------------------------------------------------}
PROCEDURE Fenetre.Affiche;

Begin

     PBoutonE.SetCouleur(CoulFn_F, CoulF_F, CoulBr_F);                (* Fentre *)
     PBoutonE.SetPosition(X1f, Y1f, X2f, Y2f, EpBord_F);
     PBoutonE.Affiche;

     PBoutonS.SetCouleur(CoulB_F, CoulF_F, CoulBr_F);                (* Bouton fermeture *)
     PBoutonS.SetPosition(X1f+EpBord_F+1, Y1f+EpBord_F+1, X1f+EpBord_F+25, Y1f+EpBord_F+24,0);
     PBoutonS.Affiche;
     SetColor(CoulMB_F);
     Rectangle(X1f+10,Y1f+14,X1f+21,Y1f+16);
     Rectangle(X1f+9,Y1f+13,X1f+22,Y1f+17);

     PBoutonS.SetCouleur(CoulB_F, CoulF_F, CoulBr_F);                (* Bouton agrandissement *)
     PBoutonS.SetPosition(X2f-EpBord_F-25, Y1f+EpBord_F+1, X2f-EpBord_F-1, Y1f+EpBord_F+24,0);
     PBoutonS.Affiche;
     SetColor(CoulMB_F);
     OutTextXY(X2f-19,Y1f+9,Chr(30));
     OutTextXY(X2f-19,Y1f+16,Chr(31));

     PBoutonS.SetCouleur(CoulB_F, CoulF_F, CoulBr_F);                (* Bouton rduction *)
     PBoutonS.SetPosition(X2f-EpBord_F-50, Y1f+EpBord_F+1, X2f-EpBord_F-26, Y1f+EpBord_F+24,0);
     PBoutonS.Affiche;
     SetColor(CoulMB_F);
     OutTextXY(X2f-44,Y1f+13,Chr(31));

     SetColor(CoulBr_F);                                               (* Ligne *)
     Line(X1f+EpBord_F, Y1f+EpBord_F+25, X2f-EpBord_F, Y1f+EpBord_F+25);

     PBoutonE.SetCouleur(CoulBT_F, CoulF_F, CoulBr_F);                (* Bouton titre *)
     PBoutonE.SetPosition(X1f+EpBord_F+32, Y1f+EpBord_F+2, X2f-EpBord_F-57, Y1f+EpBord_F+23,0);
     PBoutonE.Affiche;

End;

{---------------------------------------------------------------------------}
PROCEDURE Fenetre.Cache;

Begin
     SetFillStyle(1,CoulF_F);
     Bar(X1f, Y1f, X2f, Y2f);

End;

{---------------------------------------------------------------------------}

{**************************************************************************}
PROCEDURE INITIALISATION_CARTE_GRAPHIQUE(CheminGraph : String);
VAR
    GraphPilot, GraphMode : Integer;

BEGIN
       GraphPilot := Detect;
                  InitGraph(GraphPilot,GraphMode,CheminGraph);
                  If GraphResult <> GrOk Then
       Halt(1);
END;

{**************************************************************************}

BEGIN
      INITIALISATION_CARTE_GRAPHIQUE('C:\TP7\BGI');
      PBoutonE.Init(0,0,0,0);
      PBoutonS.Init(0,0,0,0);
      Fen.Init(0,0,0,0);

     Fen.SetCouleur(7,3,3,7,12,8);
     Fen.SetPosition(50,50,600,400,3);
     Fen.Affiche;
{     Delay(3000);
     Fen.Cache;

     PBoutonE.SetCouleur(CoulBT_F, CoulF_F, CoulBr_F);                (* Barre dfilement *)
     PBoutonE.SetPosition(X2f-EpBord_F-20, Y1f+EpBord_F+60, X2f-EpBord_F-2, Y2f-EpBord_F-5,0);
     PBoutonE.Affiche;}

      ReadLn;
      CloseGraph;
END.



