PROGRAM Laid_ARJ;                     { au 10/06/97 }
                           { Aide  la dcompression des fichier .exe avec mot de passe }

{$M 16384,0,97536}

USES
      Dos, Crt, Graph;

CONST

    Entree      = #13;
    FlecheHaut  = #72;
    FlecheBas   = #80;
    PageBas     = #81;
    F10         = #68;
    CtrlEnd     = #117;

VAR
    GraphPilot, GraphMode   : Integer;
    x1, y1, x2, y2, i, Choi : Integer;
    Touche                  : Char;
    Commande                : String;
    NomFichier              : String[15];
    Chemin                  : String[50];
    NbEssais                : Integer;
    Erreur,CodeES           : Integer;
    Touch                   : Char;
    Rep_Depart, Depart      : String[50];
    Repertoire              : String[50];
    Lecteur                 : String[2];
    Nbre_Caract, NbrDisk    : Integer;
    iStr                    : String[2];
    Code                    : String[20];
    MotPasse                : Boolean;



    PROCEDURE INITIALISATION_CARTE_GRAPHIQUE; FORWARD;
    PROCEDURE FOND_MENU;                      FORWARD;
    PROCEDURE MENU;                           FORWARD;
    PROCEDURE CHOIX;                          FORWARD;

{**************************************************************************}
PROCEDURE TOUCHE_ENTREE;

BEGIN
     Repeat
            Touche := ReadKey;
     Until Touche = Entree;
END;

{**************************************************************************}
PROCEDURE REPERTOIRE_DEPART;

BEGIN
     ChDir(Rep_Depart);
END;

{**************************************************************************}
PROCEDURE EXECUTE (Commande : String);

BEGIN
     SwapVectors;
                 Exec(GetEnv('ComSpec'), '/C' + Commande);
     SwapVectors;
END;

{**************************************************************************}
PROCEDURE CONTROLE_NUM_ENTIER(xPos,yPos : Integer; VAR Variable_Ent : Integer);

VAR       Num , i, Long_Var_Ent : Integer;
          Ent_Char : String;

Begin
           Repeat
              {$I-}
                   TextColor(15);
                    GoToXY(xPos,yPos);
                     ReadLn(Variable_Ent);
              {$I+}
              Num := IOResult;
              If Num <> 0 Then
                 Begin
                      TextColor(LightGreen+Blink);
                       Write(Chr(7));
                        GoToXY(7,yPos+2);
                      Write('Format entier exig!. Frappez sur ENTREE.');

                      Str(Variable_Ent,Ent_Char);
                      Long_Var_Ent := Length(Ent_Char);

                      Touche_Entree;

                      GoToXY(7,yPos+2);
                      Write('                                         ');

                      For i:=0 To Long_Var_Ent+10 Do
                                          Begin
                                               GoToXY(xPos+i,yPos);
                                               Write(' ');
                                          End;
                 End;
           Until Num = 0;
End;

{**************************************************************************}
PROCEDURE CONTROLE_FICHIER;

VAR

   Repert : Text;
   Chemin_Fichier : String;

BEGIN
     NbEssais := 0;
     GetDir(0,Repertoire);

     Repeat
           TextColor(15);
           GoToXY(33,11);
            Write('                             ');
             GoToXY(33,11);
              ReadLn(NomFichier);

       Chemin_Fichier := Repertoire + '\' + NomFichier;

       {$I-};
             Assign(Repert,Chemin_Fichier);
             Reset(Repert);
             Close(Repert);
       {$I+};

       CodeES := IOResult;
       If CodeES <> 0  Then
          Begin
               NbEssais := NbEssais + 1;
               GoToXY(20,22);
               TextColor(LightGreen+Blink);
               Write(' Ce fichier n''existe pas. Frappez sur ENTREE ');

               Touche_Entree;

               If NbEssais = 3 Then
                           Begin
                                INITIALISATION_CARTE_GRAPHIQUE;
                                 FOND_MENU;
                                  MENU;
                                   CHOIX;
                                    CloseGraph;
                                Halt(1);
                           End
               Else
               GoToXY(20,22);
               Write('                                               ');

          End;
     Until CodeES = 0 ;
END;

{**************************************************************************}
PROCEDURE CONTROLE_CHEMIN;

BEGIN

     NbEssais := 0;
     Repeat
           GoToXY(40,15);
             TextColor(15);
               ReadLn(Chemin);
        {$I-};
       ChDir(Chemin);                 { vrification du chemin }
        {$I+};
       CodeES := IOResult;
       If CodeES <> 0  Then
          Begin
               NbEssais := NbEssais + 1;
               GoToXY(5,17);
               TextColor(LightGreen+Blink);
               Write(Chr(7));
               Write('  Chemin introuvable. Frappez sur ENTREE ');
               ReadLn;

               If NbEssais = 3 Then
                           Begin
                                INITIALISATION_CARTE_GRAPHIQUE;
                                 FOND_MENU;
                                  MENU;
                                   CHOIX;
                                    CloseGraph;
                                Halt(1);
                           End
               Else
               GoToXY(39,15);
               Write('                            ');
               GoToXY(5,17);
               Write('                                          ');
          End;

     Until CodeES = 0 ;

     Repertoire_Depart;
END;

{**************************************************************************}
PROCEDURE FOND_ECRAN;

VAR
    i,j : Byte;

BEGIN
      ClrScr;
      TextBackGround(5);
      ClrScr;
      TextColor(White);
      GotoXY(2,1);
      Write(Chr(218));
      For i:=2 To 77 Do
             Write(Chr(196));
             Write(Chr(191));
             GoToXY(2,24);
             Write(Chr(192));
      For i:=3 To 78 Do
              Write(Chr(196));
              Write(Chr(217));
      For j:=2 To 23 Do
          Begin
              GoToXY(2,j);
                Write(Chr(179));
              GoToXY(79,j);
                Write(Chr(179));
          End;

       TextColor(1);                             { deuxime fond }
       For j:=2 To 23 Do
         Begin
           GoToXY(4,j);
                   For i:=1 To 74 Do
                   Begin
                        Write(Chr(219));
                   End;
         End;
END;

{**************************************************************************}
PROCEDURE DOS_ERROR;

BEGIN
     TextColor(12);
        GoToXY(5,16);
           Write ('Impossible d''excuter Commande.com');
     TextColor(Green);
        GoToXY(7,20);
           Write('Frapper sur la touche ENTREE');
     Touche_Entree;
END;

{**************************************************************************}
PROCEDURE Lecture_Code;

Begin
     GoToXY(5,19);
       Write(' Donner votre mot de passe : ');
     GoToXY(35,19);
       ReadLn(Code);
End;

{**************************************************************************}
PROCEDURE Question_Code;

Begin
     Repeat

      Case Choi Of

      1..3 : Begin
                  GoToXY(60,17);
                    Write('        ');
                      TextColor(LightGreen);
                        GoToXY(5,17);
                      Write(' Voulez-vous comprimer avec un mot de passe (O/N) ? : ');
                    GoToXY(60,17);
                  TextColor(15);
             End;
      4..5 : Begin
                  GoToXY(57,17);
                    Write('        ');
                      TextColor(LightGreen);
                       GoToXY(5,17);
                     Write(' Avez-vous comprim avec un mot de passe (O/N) ? : ');
                   GoToXY(57,17);
                 TextColor(15);
             End;
       End;
       ReadLn(Touche);
     Until (UpCase(Touche) = 'O') Or (UpCase(Touche) = 'N');

     If (UpCase(Touche) = 'O') Then
                              Begin
                                   MotPasse := True;
                                   Lecture_Code;
                                   If Choi = 2 Then
                                      Begin
                                           TextColor(LightRed);
                                           GoToXY(5,21); Write('N.B: ');
                                           TextColor(11);
                                           GoToXY(10,21);
                                           Write('Pour dcomprimer taper ---> ',NomFichier,' -g',Code);
                                           GoToXY(62,22);
                                           TextColor(15);
                                           Write('---> ENTREE');
                                           ReadLn;
                                      End;
                              End;
End;

{**************************************************************************}
PROCEDURE Compr_En_Arj;

BEGIN
     Fond_Ecran;
      TextBackGround(1);
       TextColor(14);
        GoToXY(5,5);
         Write(' Cette commande permet d''archiver tout les fichiers du rpertoire');
         GoToXY(5,7);
         Write(' courant dans le chemin spcifi. Le rsultat est un fichier.arj.');
    Repeat
      TextColor(LightGreen);
       GoToXY(5,11);
        Write(' Donnez le nom sous lequel vous voulez archiver les fichiers :           ');
         GoToXY(5,13);
          Write('  << 8 caractres max et sans extension >>');
           TextColor(15);
           GoToXY(68,11);
            ReadLn(NomFichier);
             Nbre_Caract := Length(NomFichier);
    Until Nbre_Caract <= 8;

       GoToXY(5,15);
        Write(' Donnez le chemin de sauvegarde : ');
         Controle_Chemin;

     Question_Code;

     TextColor(3);
     TextBackGround(Black);
      ClrScr;
    If MotPasse = True Then  Commande := 'Arj a -g' + Code + ' ' + Chemin + '\' + NomFichier;
    If MotPasse = False Then Commande := 'Arj a ' + Chemin + '\' + NomFichier;

    Execute(Commande);

             TextColor(Green);
             WriteLn;Write('Frapper sur la touche ENTREE');

             Touche_Entree;

     If DosError <> 0 Then
        Begin
             DOS_ERROR;
        End;
End;

{***************************************************************************}
PROCEDURE Compr_En_Exe;

BEGIN
     FOND_ECRAN;
      TextBackGround(1);
       TextColor(14);
        GoToXY(5,3);
         Write(' Cette commande permet d''archiver tout les fichiers du rpertoire');
         GoToXY(5,5);
         Write(' courant dans le chemin spcifi. Le rsultat est un fichier .exe,');
         GoToXY(5,7);
         Write(' c''est--dire qui se dcomprime tout seul une fois excut.');

    Repeat
      TextColor(LightGreen);
       GoToXY(5,11);
        Write(' Donnez le nom sous lequel vous voulez archiver les fichiers :           ');
         GoToXY(5,13);
          Write('  << 8 caractres max et sans extension >>');
           TextColor(15);
           GoToXY(68,11);
            ReadLn(NomFichier);
             Nbre_Caract := Length(NomFichier);
    Until Nbre_Caract <= 8;

      TextColor(LightGreen);
       GoToXY(5,15);
        Write(' Donnez le chemin de sauvegarde : ');
         Controle_Chemin;

     Question_Code;

     TextColor(3);
     TextBackGround(Black);
      ClrScr;
    If MotPasse = True Then  Commande := 'Arj a -je -g' + Code + ' ' + Chemin + '\' + NomFichier;
    If MotPasse = False Then Commande := 'Arj a -je ' + Chemin + '\' + NomFichier;

    Execute(Commande);

             TextColor(Green);
             WriteLn;Write('Frapper sur la touche ENTREE');

             Touche_Entree;

     If DosError <> 0 Then
        Begin
             DOS_ERROR;
        End;
END;

{**************************************************************************}
PROCEDURE Compr_Sur_Disquettes;

BEGIN
     FOND_ECRAN;
      TextBackGround(1);
       TextColor(14);
        GoToXY(5,3);
         Write(' Cette commande permet d''archiver tout les fichiers du rpertoire');
         GoToXY(5,5);
         Write(' courant avec ses sous-rpertoires dans le lecteur spcifi.');
         GoToXY(5,7);
         Write(' La dtection de la capacit de la disquette est automatique.');

    Repeat
      TextColor(LightGreen);
       GoToXY(5,11);
        Write(' Donnez le nom sous lequel vous voulez archiver les fichiers :           ');
         GoToXY(5,13);
          Write('  << 8 caractres max et sans extension >>');
           TextColor(15);
           GoToXY(68,11);
            ReadLn(NomFichier);
             Nbre_Caract := Length(NomFichier);
    Until Nbre_Caract <= 8;

      TextColor(LightGreen);
       GoToXY(5,15);
        Write('Donnez le lecteur de sauvegarde : ');
         Controle_Chemin;

     Question_Code;

     TextColor(3);
     TextBackGround(Black);
      ClrScr;
    If MotPasse = True Then  Commande := 'Arj a -r -va -g' + Code + ' ' + Chemin + '\' + NomFichier;
    If MotPasse = False Then Commande := 'Arj a -r -va ' + Chemin + NomFichier;

    Execute(Commande);

             TextColor(Green);
             WriteLn;Write('Frapper sur la touche ENTREE');

             Touche_Entree;

     If DosError <> 0 Then
        Begin
             DOS_ERROR;
        End;
END;

{**************************************************************************}
PROCEDURE Decompr_Arj;

BEGIN
     FOND_ECRAN;
      TextBackGround(1);
       TextColor(14);
        GoToXY(5,5);
         Write(' Cette commande permet de dsarchiver les fichiers .arj  du chemin');
          GoToXY(5,7);
           Write(' de dpart vers le chemin de destination.');

             TextColor(LightGreen);
              GoToXY(5,11);
               Write(' Donnez le nom du fichier : ');
                GoToXY(5,13);
                 Write('  << 8 caractres max et sans extension >>');

          Repeat
                GoToXY(33,11);
                  Write('                     ');
                   TextColor(15);
                    GoToXY(33,11);
                     ReadLn(NomFichier);
                      Nbre_Caract := Length(NomFichier);
          Until Nbre_Caract <= 8;

             TextColor(LightGreen);
              GoToXY(5,15);
               Write(' Donnez le chemin de dpart : ');
                TextColor(15);
                 ReadLn(Depart);
             GoToXY(5,15);
              Write('                                                  ');

             TextColor(LightGreen);
              GoToXY(5,15);
               Write(' Donnez le chemin de destination : ');
                TextColor(15);
                 Controle_Chemin;

     Question_Code;

     TextColor(3);
     TextBackGround(Black);
      ClrScr;
     If MotPasse = True Then  Commande := 'Arj e -g' + Code + ' ' + Depart + '\' + NomFichier + ' ' + Chemin;
     If MotPasse = False Then Commande := 'Arj e ' + Depart + '\' + NomFichier + ' ' + Chemin;

     Execute(Commande);

             TextColor(Green);
             WriteLn;Write('Frapper sur la touche ENTREE');

             Touche_Entree;

     If DosError <> 0 Then
                         Begin
                              DOS_ERROR;
                         End;
END;

{***********************************************************************}
PROCEDURE Decompr_Disquettes;

BEGIN
     FOND_ECRAN;
      TextBackGround(1);
       TextColor(14);
        GoToXY(5,5);
         Write(' Cette commande permet de dsarchiver les fichiers .arj,  qui ont t');
         GoToXY(5,7);
         Write(' compresss sur plusieurs disquettes, vers le chemin de destination.');

           TextColor(LightGreen);
            GoToXY(5,11);
             Write(' Donnez le nom du fichier (sans extension) : ');

          Repeat
                GoToXY(50,11);
                  Write('                      ');
                   TextColor(15);
                    GoToXY(50,11);
                     ReadLn(NomFichier);
                      Nbre_Caract := Length(NomFichier);
          Until Nbre_Caract <= 12;

             TextColor(LightGreen);
              GoToXY(5,13);
               Write(' Donner le nombre de disquettes : ');
                 Controle_Num_Entier(40, 13, NbrDisk);
              TextColor(LightGreen);
               GoToXY(5,15);
                Write(' Donnez le chemin de destination : ');
                {TextColor(15);}
                 Controle_Chemin;

         Repeat
              GoToXY(38,17);
               Write('               ');
                TextColor(LightGreen);
                 GoToXY(5,17);
                  Write(' Donnez le lecteur de dpart (sans ":")  : ');
                   TextColor(15);
                    ReadLn(Lecteur);
         Until (Lecteur = 'a') Or (Lecteur = 'b') Or
                                  (Lecteur = 'A') Or (Lecteur = 'B');

     Question_Code;

     TextColor(3);
     TextBackGround(Black);
      ClrScr;
             Lecteur := Lecteur + ':\';
      If MotPasse = True Then  Commande := 'Arj x -g' + Code + ' ' + Lecteur + NomFichier + '.arj' + ' ' + Chemin;
      If MotPasse = False Then Commande := 'Arj x ' + Lecteur + NomFichier + '.arj' + ' ' + Chemin;

      Execute(Commande);

          For i:=2 To NbrDisk Do
              Begin
                   TextColor(15);
                    WriteLn;Write(' Mettre la disquette N "',i,'" puis --> ENTREE');
                     Touche_Entree; WriteLn;
                      TextColor(3);
                        TextBackGround(Black);
                        ClrScr;
                     Str(i-1, iStr);
          If i < 11 Then
             Begin
              If MotPasse = True Then  Commande := 'Arj x -g' + Code + ' ' + Lecteur + NomFichier + '.A0'+ iStr + ' ' + Chemin;
              If MotPasse = False Then Commande := 'Arj x ' + Lecteur + NomFichier + '.A0'+ iStr + ' ' + Chemin;
             End
             Else
             Begin
              If MotPasse = True Then  Commande := 'Arj x -g' + Code + ' ' + Lecteur + NomFichier + '.A'+ iStr + ' ' + Chemin;
              If MotPasse = False Then Commande := 'Arj x ' + Lecteur + NomFichier + '.A'+ iStr + ' ' + Chemin;
             End;

                   Execute(Commande);
              End;
              TextColor(15);
                WriteLn;Write(' Frapper sur la touche ENTREE');
                  Touche_Entree;

     If DosError <> 0 Then
                         Begin
                              DOS_ERROR;
                         End;
END;

{**************************************************************************}
PROCEDURE Commande_Quelconque;

BEGIN
     FOND_ECRAN;
      TextBackGround(1);
       TextColor(14);
        GoToXY(5,5);
         Write(' Cette commande permet d''utiliser toutes les commandes possibles.');

             TextColor(LightGreen);
              GoToXY(5,11);
               Write(' Tappez votre commande : ');
                 TextColor(15);
                  ReadLn(Commande);

    TextColor(3);
     TextBackGround(Black);
      ClrScr;
             Execute(Commande);

             TextColor(Green);
             WriteLn;Write('Frapper sur la touche ENTREE');

             Touche_Entree;

     If DosError <> 0 Then
                         Begin
                              DOS_ERROR;
                         End;
END;

{**************************************************************************}

{==========================================================================}
{------------------ *** MENU GRAPHIQUE ***  -------------------------------}
{==========================================================================}
PROCEDURE INITIALISATION_CARTE_GRAPHIQUE;

BEGIN
       GraphPilot:=Detect;
       InitGraph(GraphPilot,GraphMode,'C:\TP7\BGI');
       If GraphResult <> GrOk Then
       Halt(1);
END;

{***************************************************************************}
PROCEDURE CENTRE_TEXTE (x1,y1,x2,y2 : Integer; Texte : String);

Var   Long_Texte  : Byte;

BEGIN

     Long_Texte := Length(Texte)*8 Div 2 ;
     OutTextXY((x1+x2) Div 2 - Long_Texte,
                                     (y2-y1) Div 2 + y1 - 3 , Texte);
END;

{***************************************************************************}
PROCEDURE BOUTON1S (Hor1,Ver1,Hor2,Ver2 : Integer; CoulBouton : Word);

BEGIN
      SetFillStyle(1,CoulBouton);
      Bar(Hor1,Ver1,Hor2,Ver2);
      SetLineStyle(0,1,1);
      SetColor(Black);
      Rectangle(Hor1,Ver1,Hor2,Ver2);

      SetColor(15);
      Line(Hor1,Ver1,Hor2,Ver1);
      Line(Hor1,Ver1,Hor1,Ver2-1);
END;

{***************************************************************************}
PROCEDURE BOUTON1E (Hor1,Ver1,Hor2,Ver2 : Integer; CoulBouton : Word);

BEGIN
      SetFillStyle(1,CoulBouton);
      Bar(Hor1,Ver1,Hor2,Ver2);
      SetLineStyle(0,1,1);
      SetColor(15);
      Rectangle(Hor1,Ver1,Hor2,Ver2);
      SetColor(Black);
      Line(Hor1,Ver1,Hor2,Ver1);
      Line(Hor1,Ver1,Hor1,Ver2+1);
END;

{***************************************************************************}
PROCEDURE BOUTON2S (Hor1,Ver1,Hor2,Ver2 : Integer; CoulBouton : Word);

BEGIN
      SetFillStyle(1,CoulBouton);
      Bar(Hor1,Ver1,Hor2,Ver2);
      SetLineStyle(0,1,3);
      SetColor(Black);
      Rectangle(Hor1,Ver1,Hor2,Ver2);

      SetColor(15);
      SetLineStyle(0,1,1);
      Line(Hor1,Ver1-1,Hor2,Ver1-1);
      Line(Hor1,Ver1,Hor2-1,Ver1);
      Line(Hor1,Ver1+1,Hor2-2,Ver1+1);

      Line(Hor1-1,Ver1,Hor1-1,Ver2);
      Line(Hor1,Ver1,Hor1,Ver2-1);
      Line(Hor1+1,Ver1,Hor1+1,Ver2-2);
END;

{***************************************************************************}
PROCEDURE BOUTON2E (Hor1,Ver1,Hor2,Ver2 : Integer; CoulBouton : Word);

BEGIN
      SetFillStyle(1,CoulBouton);
      Bar(Hor1,Ver1,Hor2,Ver2);
      SetLineStyle(0,1,3);
      SetColor(15);
      Rectangle(Hor1,Ver1,Hor2,Ver2);

      SetColor(Black);
      SetLineStyle(0,1,1);
      Line(Hor1,Ver1-1,Hor2,Ver1-1);
      Line(Hor1,Ver1,Hor2-1,Ver1);
      Line(Hor1,Ver1+1,Hor2-2,Ver1+1);

      Line(Hor1-1,Ver1,Hor1-1,Ver2);
      Line(Hor1,Ver1,Hor1,Ver2-1);
      Line(Hor1+1,Ver1,Hor1+1,Ver2-2);
END;

{***************************************************************************}
PROCEDURE FOND_MENU;

BEGIN
      SetFillStyle(8,7);
       Bar(0,0,650,450);
        SetLineStyle(0,1,3);
         Rectangle(20-5,20-5,600+15,420+5);
         SetColor(9);
        SetTextStyle(0,0,1);
       SetFillStyle(1,3);
      Bar(20,20,610,420);
END;

{***************************************************************************}
PROCEDURE MENU;

BEGIN
       Bouton1S(21,26,164,271,13);
       Bouton1E(25,30,160,267,1);
       SetColor(1);
     SetColor(White);
      SetTextStyle(0,0,0);
       OutTextxy(55,45,'Interface');
        OutTextxy(55,75,'graphique');
         OutTextxy(75,105,'pour');
          OutTextxy(75,135,'Arj');
          SetColor(11);
           OutTextxy(50,165,'Version 2.2');
     SetColor(12);
      OutTextxy(30,200,'Copyright 94/97');
      SetColor(White);
       OutTextxy(40,225,'par:');
      SetColor(LightGreen);
       OutTextxy(80,225,'Lad');
      OutTextxy(80,245,'MESSAOUDI');

      SetColor(12);
        Bouton1E(190,26,465,59,8);
        SetTextStyle(1,0,4);
        SetColor(15);
         OutTextxy(150,22,'   MENU PRINCIPAL');
          SetTextStyle(0,0,1);

      SetViewPort(30,100,600,420,False);

  Begin
       x1:=145; y1:=-5; x2:=440; y2:=15;

       For i:=1 to 8 Do
           Begin
                  Bouton1S(x1-2,y1-2,x2+2,y2+2,7);
                  Bouton1S(x1,y1,x2,y2,7);
                  x1:=x1+15; y1:=y1+30;x2:=x2-15; y2:=y2+30;
           End;

     SetColor(black);

     Centre_Texte(145,-5,440,15,'Compresser en .arj');
     Centre_Texte(160,25,425,45,'Compresser en .exe');
     Centre_Texte(175,55,410,75,'Comp.sur disquettes');
     Centre_Texte(190,85,395,105,'Dcompresser les .arj');
     Centre_Texte(205,115,380,135,'Dcomp. disquettes');
     Centre_Texte(220,145,365,165,'Commande');
     Centre_Texte(235,175,350,195,'Sortie');
     Centre_Texte(250,205,335,225,'Aide');

     SetLineStyle(0,1,3);
      Bouton1E(400,293,572,312,7);
       SetColor(1);
          Centre_Texte(400,293,572,312,'ENTREE pour valider');

      Bouton1E(0,293,215,312,7);
      SetColor(1);
        Centre_Texte(0,293,215,312,'Dplacement pour choisir');
  End;
END;
{**********************************************************************}
PROCEDURE ECRI_TITRES;

BEGIN
     SetColor(black);

       Centre_Texte(145,-5,440,15,'Compresser en .arj');
       Centre_Texte(160,25,425,45,'Compresser en .exe');
       Centre_Texte(175,55,410,75,'Comp.sur disquettes');
       Centre_Texte(190,85,395,105,'Dcompresser les .arj');
       Centre_Texte(205,115,380,135,'Dcomp. disquettes');
       Centre_Texte(220,145,365,165,'Commande');
       Centre_Texte(235,175,350,195,'Sortie');
       Centre_Texte(250,205,335,225,'Aide');
END;

{**********************************************************************}
PROCEDURE ECRIT_TITRES (Choi : Integer);

BEGIN
     SetColor(black);
     Case Choi Of
      1 : Begin
                Centre_Texte(145,-5,440,15,'Compresser en .arj');
                Centre_Texte(160,25,425,45,'Compresser en .exe');
                Centre_Texte(250,205,335,225,'Aide');
          End;

      2 : Begin
                Centre_Texte(145,-5,440,15,'Compresser en .arj');
                Centre_Texte(160,25,425,45,'Compresser en .exe');
                Centre_Texte(175,55,410,75,'Comp.sur disquettes');
          End;

      3 : Begin
                 Centre_Texte(160,25,425,45,'Compresser en .exe');
                 Centre_Texte(175,55,410,75,'Comp.sur disquettes');
                 Centre_Texte(190,85,395,105,'Dcompresser les .arj');
          End;

      4 : Begin
                 Centre_Texte(175,55,410,75,'Comp.sur disquettes');
                 Centre_Texte(190,85,395,105,'Dcompresser les .arj');
                 Centre_Texte(205,115,380,135,'Dcomp. disquettes');
          End;

      5 : Begin
                 Centre_Texte(190,85,395,105,'Dcompresser les .arj');
                 Centre_Texte(205,115,380,135,'Dcomp. disquettes');
                 Centre_Texte(220,145,365,165,'Commande');
          End;

      6 : Begin
                 Centre_Texte(205,115,380,135,'Dcomp. disquettes');
                 Centre_Texte(220,145,365,165,'Commande');
                 Centre_Texte(235,175,350,195,'Sortie');
          End;

      7 : Begin
                 Centre_Texte(220,145,365,165,'Commande');
                 Centre_Texte(235,175,350,195,'Sortie');
                 Centre_Texte(250,205,335,225,'Aide');
          End;

      8 : Begin
                Centre_Texte(235,175,350,195,'Sortie');
                Centre_Texte(250,205,335,225,'Aide');
                Centre_Texte(145,-5,440,15,'Compresser en .arj');
          End;
     End;
END;

{**********************************************************************}
PROCEDURE AIDE;

BEGIN
      Execute('Arj -?');

     If DosError <> 0 Then
         Begin
              DOS_ERROR;
         End;
END;

{*************************************************************************}
PROCEDURE EFFACE (Choi : Integer) ;

BEGIN

       Case Choi Of
         1: Begin
                 x1:=145; y1:=-5; x2:=440; y2:=15;
            End;
         2: Begin
                 x1:=160; y1:=25; x2:=425; y2:=45;
            End;
         3: Begin
                 x1:=175; y1:=55; x2:=410; y2:=75;
            End;
         4: Begin
                 x1:=190; y1:=85; x2:=395; y2:=105;
            End;
         5: Begin
                 x1:=205; y1:=115; x2:=380; y2:=135;
            End;
         6: Begin
                 x1:=220; y1:=145; x2:=365; y2:=165;
            End;
         7: Begin
                 x1:=235; y1:=175; x2:=350; y2:=195;
            End;
         8: Begin
                 x1:=250; y1:=205; x2:=335; y2:=225;
            End;
       End;
                Line(x1,y1,x1,y2+1);
                Bouton1S(x1,y1,x2,y2,7);
END;

{**************************************************************************}
PROCEDURE CHOIX;

BEGIN
      Choi := 1;

      Bouton1E(145,-5,440,15,14);
      ECRI_TITRES;

      Repeat
            Touche:=ReadKey;
       Begin
           If Touche = FlecheBas  Then Choi := Choi+1;
           If Touche = FlecheHaut Then Choi := Choi-1;
           If Choi >=9 Then Choi := 1;
           If Choi < 1 Then Choi := 8;
       End;

      Case Choi Of
      1: Begin
              EFFACE(Choi);EFFACE(Choi+7);EFFACE(Choi+1);
              Bouton1E(145,-5,440,15,14);
              ECRIT_TITRES(Choi);
                 If touche = Entree Then
                        Begin
                             RestoreCrtMode;
                              Compr_en_arj;
                               SetGraphMode(GraphMode);
                                FOND_MENU;
                               MENU;
                               Bouton1E(145,-5,440,15,14);
                               ECRI_TITRES;
                        End;
         End;
      2: Begin
              EFFACE(Choi);EFFACE(Choi-1);EFFACE(Choi+1);
              Bouton1E(160,25,425,45,14);
              ECRIT_TITRES(Choi);
                 If Touche = Entree Then
                        Begin
                             RestoreCrtMode;
                              Compr_en_exe;
                               SetGraphMode(GraphMode);
                                FOND_MENU;
                               MENU;
                               Bouton1E(160,25,425,45,14);
                               ECRI_TITRES;
                        End;
         End;
      3: Begin
              EFFACE(Choi);EFFACE(Choi-1);EFFACE(Choi+1);
              Bouton1E(175,55,410,75,14);
              ECRIT_TITRES(Choi);
                 If Touche = Entree Then
                        Begin
                             RestoreCrtMode;
                              Compr_sur_disquettes;
                               SetGraphMode(GraphMode);
                                FOND_MENU;
                               MENU;
                               Bouton1E(175,55,410,75,14);
                               ECRI_TITRES;
                        End;
         End;
      4: Begin
              EFFACE(Choi);EFFACE(Choi-1);EFFACE(Choi+1);
              Bouton1E(190,85,395,105,14);
              ECRIT_TITRES(Choi);
                 If Touche = Entree Then
                        Begin
                             RestoreCrtMode;
                              Decompr_arj;
                               SetGraphMode(GraphMode);
                                FOND_MENU;
                               MENU;
                               Bouton1E(190,85,395,105,14);
                               ECRI_TITRES;

                        End;
         End;
      5: Begin
              EFFACE(Choi);EFFACE(Choi-1);EFFACE(Choi+1);
              Bouton1E(205,115,380,135,14);
              ECRIT_TITRES(Choi);
                 If Touche = Entree Then
                        Begin
                             RestoreCrtMode;
                              Decompr_disquettes;
                               SetGraphMode(GraphMode);
                                FOND_MENU;
                               MENU;
                               Bouton1E(205,115,380,135,14);
                               ECRI_TITRES;
                        End;
         End;
      6: Begin
              EFFACE(Choi);EFFACE(Choi-1);EFFACE(Choi+1);
              Bouton1E(220,145,365,165,14);
              ECRIT_TITRES(Choi);
                 If Touche = Entree Then
                        Begin
                             RestoreCrtMode;
                              Commande_Quelconque;
                               SetGraphMode(GraphMode);
                                FOND_MENU;
                               MENU;
                               Bouton1E(220,145,365,165,14);
                               ECRI_TITRES;
                        End;
         End;
      7: Begin
              EFFACE(Choi);EFFACE(Choi-1);EFFACE(Choi+1);
              Bouton1E(235,175,350,195,12);
              ECRIT_TITRES(Choi);
                 If Touche = Entree Then
                        Begin
                             CloseGraph;
                              RestoreCrtMode;
                             HALT(1);
                        End;
         End;
      8: Begin
              EFFACE(Choi);EFFACE(Choi-1);EFFACE(Choi-7);
              Bouton1E(250,205,335,225,10);
              ECRIT_TITRES(Choi);
                 If Touche = Entree Then
                        Begin
                             RestoreCrtMode;
                              AIDE;
                               SetGraphMode(GraphMode);
                                FOND_MENU;
                               MENU;
                              Bouton1E(250,205,335,225,10);
                             ECRI_TITRES;
                        End;
         End;
      End;

      Until (Touche=CtrlEnd);
END;

{***************************************************************************}
{**************************************************************************}
       {-----------------* PROGRAMME PRINCIPAL *--------------------}

BEGIN
     GetDir(0,Rep_Depart);
     MotPasse := False;
     INITIALISATION_CARTE_GRAPHIQUE;
     FOND_MENU;
     MENU;
     CHOIX;
     CloseGraph;
END.
