PROGRAM Lettres;                                  { au 11/03/94 }

USES
   Crt,graph;

CONST
    Motif1 : FillPatternType = ($CC, $15, $BD,
      $15, $BC, $15, $BD, $15);

VAR
   x1,y1,x2,y2 : Integer;

{==========================================================================}
{==========================================================================}
PROCEDURE INITIALISATION_CARTE_GRAPHIQUE(CheminGraph : String);

VAR
    GraphPilot, GraphMode : Integer;

BEGIN
       GraphPilot := Detect;
        InitGraph(GraphPilot,GraphMode,CheminGraph);
        If GraphResult <> GrOk Then
       Halt(1);
END;
{**************************************************************************}
PROCEDURE BOUTON1S(Hor1,Ver1,Hor2,Ver2 : Integer; CoulBouton : Word);

BEGIN
      SetFillStyle(1,CoulBouton);
      Bar(Hor1,Ver1,Hor2,Ver2);
      SetLineStyle(0,1,1);
      SetColor(Black);
      Rectangle(Hor1,Ver1,Hor2,Ver2);
      SetColor(15);
      Line(Hor1,Ver1,Hor2,Ver1);
      Line(Hor1,Ver1,Hor1,Ver2-1);

END;

{**************************************************************************}
PROCEDURE BOUTON1S_M(Hor1,Ver1,Hor2,Ver2 : Integer; CoulBouton, Motif_B : Word);

BEGIN
      SetFillStyle(Motif_B,CoulBouton);
      Bar(Hor1,Ver1,Hor2,Ver2);
      SetLineStyle(0,1,1);
      SetColor(Black);
      Rectangle(Hor1,Ver1,Hor2,Ver2);
      SetColor(15);
      Line(Hor1,Ver1,Hor2,Ver1);
      Line(Hor1,Ver1,Hor1,Ver2-1);

END;

{***************************************************************************}
PROCEDURE BOUTON1E(Hor1,Ver1,Hor2,Ver2 : Integer; CoulBouton : Word);

BEGIN
      SetFillStyle(1,CoulBouton);
      Bar(Hor1,Ver1,Hor2,Ver2);
      SetLineStyle(0,1,1);
      SetColor(15);
      Rectangle(Hor1,Ver1,Hor2,Ver2);
      SetColor(Black);
      Line(Hor1,Ver1,Hor2,Ver1);
      Line(Hor1,Ver1,Hor1,Ver2+1);

END;

{**************************************************************************}
PROCEDURE FENETRE4(X1F,Y1F,X2F,Y2F : Integer; CoulFond_F,CoulBouTitre_F,
                                         CoulBoutons_F,CoulBordure_F,Motif_B : Word;
                                         Bordure_F : Integer);

BEGIN
      Bouton1S_M(X1F-Bordure_F,Y1F-Bordure_F,
               X2F+Bordure_F,Y2F+Bordure_F,CoulBordure_F,Motif_B);       {Bordure}

      Bouton1E(X1F,Y1F,X2F,Y2F,CoulFond_F);                  {Fond de fentre}
      SetLineStyle(0,0,1);


      SetColor(0);                                               {Bouton de fermeture}
      Rectangle(X1F,Y1F,X1F+26,Y1F+25);
      Bouton1S(X1F+1,Y1F+1,X1F+24,Y1F+23,CoulBoutons_F);
        SetColor(0);
         Rectangle(X1F+7,Y1F+10,X1F+18,Y1F+12);
          Rectangle(X1F+6,Y1F+9,X1F+19,Y1F+13);

      SetColor(0);                                               {Bouton d'agrandissement}
      Rectangle(X2F-26,Y1F-1,X2F,Y1F+26);
      Bouton1S(X2F-25,Y1F+1,X2F-1,Y1F+24,CoulBoutons_f);
        SetColor(0);
         OutTextXY(X2F-16,Y1F+7,Chr(30));
          OutTextXY(X2F-16,Y1F+14,Chr(31));

      SetColor(0);                                               {Bouton de rduction}
      Rectangle(X2F-51,Y1F-1,X2F-25,Y1F+26);
      Bouton1S(X2F-50,Y1F+1,X2F-26,Y1F+24,CoulBoutons_F);
       SetColor(0);
       OutTextXY(X2F-41,Y1F+10,Chr(31));

      Bouton1E(X1F+32,Y1F+2,X2F-57,Y1F+23,CoulBouTitre_F);   {Bouton titre fentre}

      SetColor(CoulBordure_F);                                   {Bordure}
      Rectangle(X1F-1,Y1F-1,X2F+1,Y2F+1);
      Line(X1F,Y1F+26,X2F,Y1F+26);

END;


{***************************************************************************}
PROCEDURE Lettre_T;

Begin
     x1:=65 ; x2:=95 ; y1:=60 ; y2:=115;
{     x1:=round(x1*1.7);y1:=round(y1*1.7);
     x2:=round(x2*1.7);y2:=round(y2*1.7); }

     (* Lettre T *)

setcolor(15);
line(x1,y1,x1,y2-47);
line(x1,y1+8,x2-20,y1+8);
line(x1+10,y1+8,x1+10,y2);
line(x1,y1,x2-1,y1);

setcolor(0);
line(x1+10,y2,85,y2);
line(x1+20,y1+8,x1+20,y2);
line(x1+20,y1+8,x2,y1+8);
line(x2,y1+8,x2,y1);

End;
{*************************************}
PROCEDURE Autres_Lettres;

Begin
     (* Lettre L *)

{setcolor(15);
line(110,60,120,60);
line(110,60,110,115);
line(120,105,135,105);

setcolor(0);
line(120,60,120,105);
line(135,105,135,115);
line(110,115,135,115);}

{*************************************}

(* Lettre I *)

{setcolor(15);
line(110,60,120,60);
line(110,60,110,115);

setcolor(0);
line(120,60,120,115);
line(110,115,120,115);}

{*************************************}

(* Lettre H *)

setcolor(15);
line(110,60,120,60);
line(110,60,110,115);
line(140,60,150,60);
line(140,60,140,115);
line(120,85,140,85);

setcolor(0);
line(120,60,120,115);
line(110,115,120,115);
line(150,60,150,115);
line(140,115,150,115);
line(120,95,140,95);

setcolor(3);
line(120,85,120,95);
line(140,85,140,95);

{*************************************}

(* Lettre N *)

{setcolor(15);
line(110,60,120,60);
line(110,60,110,115);
line(140,60,150,60);
line(140,60,140,115);
line(120,75,140,115);

setcolor(0);
line(120,60,120,115);
line(110,115,120,115);
line(150,60,150,115);
line(140,115,150,115);
line(120,60,140,100);

setcolor(3);
line(120,60,120,75);
line(140,100,140,115);}

{*************************************}

(* Lettre M *)

{setcolor(15);
line(110,60,120,60);
line(110,60,110,115);
line(140,60,150,60);
line(140,60,140,115);
line(120,75,130,95);
line(130,75,140,60);

setcolor(0);
line(120,60,120,115);
line(110,115,120,115);
line(150,60,150,115);
line(140,115,150,115);
line(120,60,130,75);
line(130,95,140,75);

setcolor(3);
line(120,60,120,75);
line(140,61,140,75);}

{*************************************}
(* Lettre C *)

{setcolor(15);
line(110,60,120,60);
line(110,60,110,115);
line(120,60,139,60);
line(120,105,140,105);

setcolor(0);
line(140,60,140,70);
line(120,60,120,105);
line(120,70,140,70);
line(140,105,140,115);
line(110,115,140,115);

setcolor(3);
line(120,61,120,69); }

{*************************************}

(* Lettre E *)

{setcolor(15);
line(110,60,120,60);
line(110,60,110,115);
line(120,60,139,60);
line(120,82,133,82);
line(120,105,140,105);

setcolor(0);
line(140,60,140,70);
line(120,70,140,70);
line(140,105,140,115);
line(120,92,133,92);
line(133,82,133,92);
line(110,115,140,115);
line(120,60,120,105);

setcolor(3);
line(120,61,120,69);
line(120,82,120,91);}

{*************************************}

(* Lettre F *)

{setcolor(15);
line(110,60,120,60);
line(110,60,110,115);
line(120,60,139,60);
line(120,82,133,82);

setcolor(0);
line(140,60,140,70);
line(110,115,120,115);
line(120,60,120,115);
line(120,70,140,70);
line(120,92,133,92);
line(133,82,133,92);

setcolor(3);
line(120,61,120,69);
line(120,82,120,91);}

{*************************************}

(* Lettre U } *)

{setcolor(15);
line(110,60,120,60);
line(110,60,110,115);
line(140,60,150,60);
line(120,105,140,105);
line(140,60,140,105);

setcolor(0);
line(120,60,120,105);
line(110,115,120,115);
line(150,60,150,115);
line(120,115,140,115);
line(140,115,150,115);}

End;
{*************************************}
{**************************************************************************}
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
                          {*** PROGRAMME PRINCIPAL ***}
BEGIN
     INITIALISATION_CARTE_GRAPHIQUE('C:\Turbopas\Graph');
     SetFillPattern(Motif1,3);
      Bar(0,0,640,450);
       Fenetre4(20,20,620,430,3,3,7,12,4,5);
{==============================================}
lettre_t;
Autres_Lettres;
{==============================================}
ReadLn;
     CloseGraph;
     Halt(1);
END.


