PROGRAM L_Trace;                            { 29/05/94 }

USES
    Crt , Graph;
{============================ CLASSES ======================================}

TYPE
    Point = OBJECT
                  X, Y       : Integer;     { position du point }
                  CoulP      : Byte;        { couleur du point }
                  CoulF      : Byte;        { couleur du fond }

                  PROCEDURE SetCouleur (Couleur, CoulFond : Byte);
                  PROCEDURE Affiche;
                  PROCEDURE Cache;
                  PROCEDURE SetPosition (NouvoX, NouvoY : Integer);
                  PROCEDURE GetInfo (AncX, AncY : Integer; AncCoul, AncCoulF : Byte);
            End;


                        {*****  Objet Point *****}
{===========================================================================}
PROCEDURE Point.SetCouleur (Couleur, CoulFond : Byte);

Begin
     CoulP  := Couleur;
     CoulF  := CoulFond
End;

{===========================================================================}
PROCEDURE Point.Affiche;

Begin
     SetBkColor(CoulF);
     SetColor(CoulP);
     PutPixel (X,Y,GetColor);
End;

{===========================================================================}
PROCEDURE Point.Cache;
Begin
     PutPixel (X,Y,GetBkColor);
End;

{===========================================================================}
PROCEDURE Point.SetPosition (NouvoX, NouvoY : Integer);

Begin
    { Cache;}
           X := NouvoX;
           Y := NouvoY;

           If X < 1    Then  X := 1;
           If X > 639  Then  X := 639;
           If Y < 1    Then  Y := 1;
           If Y > 479  Then  Y := 479;
     Affiche;
End;

{===========================================================================}
PROCEDURE Point.GetInfo (AncX, AncY : Integer; AncCoul, AncCoulF : Byte);

BEGIN
     AncX     := X ;
     AncY     := Y;
     AncCoul  := CoulP;
     AncCoulF := CoulF;
END;

{===========================================================================}

{**************************  Programme Principal ***************************}
VAR
   Pnt                                : Point;
   Grmode, GrPilote, CodeErreur       : Integer;
   X, Y                               : Integer;
   CoulP, CoulF                       : Byte;
   i, k, R, Teta                      : Integer;

BEGIN
     GrPilote := Detect;
     InitGraph(GrPilote,GrMode,'C:\TP7\BGI');
     CodeErreur := GraphResult;
     If CodeErreur <> 0 Then Begin
                                  Write('Erreur de type Graphique ');
                                  ReadLn;
                             End
     Else

     SetBkColor(0);

 With Pnt Do
         Begin
              SetCouleur (14,0);
            For R := 0 To 20 Do
            Begin
                 For Teta:=0 To 360 Do
                     Begin
                          SetPosition (320+Round(10*R*Cos(Teta)),240+Round(10*R*Sin(Teta)));
                     End;
            End;
         End;
    ReadLn;
END.