Program Montre;

Uses  Crt, Graph, Dos;

Const
     Rayon = 180;
     X0 = 310;  Y0 = 245;   { Coordonnes du centre du repre }

     Rap = 0.0174532;

Var
   Driver, Mode, i                   : Integer;
   Heure, Minute, Seconde, Centieme  : Word;
   Xp, Yp, Alfa, Alfa1, Alfa2, Alfa3 : Real;
   Xc, Yc, Xcp, Ycp                  : Real;
   Xa1, Ya1, Xa2, Ya2, Xa3, Ya3      : Real;
   k                                 : Integer;

{===========================================================================}
PROCEDURE Boule(Xb,Yb, Rayb, Coulc, Coulb : Integer);

Begin
     SetColor(Coulc);
     SetFillStyle(1,Coulb);
     Circle(Xb,Yb,Rayb);
     FloodFill(Xb,Yb,GetColor);
End;
{============================================================================}
PROCEDURE Rotation(X1, Y1, X2, Y2, Alfa : Real);

Begin
     Xp := X1 + (X2-X1)*Cos(Alfa*Rap) - (Y2-Y1)*Sin(Alfa*Rap);
     Yp := Y1 + (Y2-Y1)*Cos(Alfa*Rap) + (X2-X1)*Sin(Alfa*Rap);
End;
{============================================================================}
PROCEDURE Dessine_Montre;

Begin
  SetColor(10);
  SetTextStyle(TriplexFont,0,4);
  OutTextxy(395,95,'1');
  OutTextxy(440,150,'2');
  OutTextxy(450,225,'3');
  OutTextxy(430,305,'4');
  OutTextxy(379,349,'5');
  OutTextxy(305,375,'6');
  OutTextxy(220,350,'7');
  OutTextxy(172,300,'8');
  OutTextxy(150,225,'9');
  OutTextxy(160,150,'10');
  OutTextxy(210,95,'11');
  OutTextxy(295,70,'12' );
  SetColor(15);
  SetUserCharSize(1,2,1,1);
  OutTextxy(278,145,'S E I K O');
  SetUserCharSize(1,2,1,1);
  Outtextxy(275,325,' QUARTZ');
  SetColor(15);
  SetBkColor(1);
    Circle(X0,Y0,Rayon);
    Circle(X0,Y0,Rayon-50);
    Boule(Round(X0),Round(Y0),5,15,5);
    Alfa := 0;
    Xc := X0;   Yc := Y0-Rayon+2;
    Repeat
         Rotation(X0, Y0, Xc, Yc, Alfa);
         Xcp := Xp;  Ycp := Yp;
         Boule(Round(Xcp),Round(Ycp),2,15,15);
         Alfa := Alfa + 6;
    Until Alfa = 360;
    Alfa := 0;
    Xc := X0;   Yc := Y0-Rayon;
    Repeat
          Rotation(X0, Y0, Xc, Yc, Alfa);
          Xcp := Xp;  Ycp := Yp;
          Boule(Round(Xcp),Round(Ycp),5,12,14);
          Alfa := Alfa + 30;
    Until Alfa = 360;
End;
{============================================================================}
PROCEDURE Dessine_Aiguille1(Xa1,Ya1 : Real);

Begin
     Xp := Xa1;   Yp := Ya1;
     SetColor(12);
     SetLineStyle(0, 0, 3);
     Line(X0,Y0,Round(Xp),Round(Yp));
End;
{============================================================================}
PROCEDURE Cache_Aiguille1(Xa1,Ya1 : Real);

Begin
     SetColor(1);
     SetLineStyle(0, 0, 3);
     Line(X0,Y0,Round(Xp),Round(Yp));
End;
{============================================================================}
PROCEDURE Dessine_Aiguille2(Xa2, Ya2 : Real);

Begin
     Xp := Xa2;   Yp := Ya2;
     SetColor(12);
     SetLineStyle(0, 0, 3);
     Line(X0,Y0,Round(Xp),Round(Yp));
End;
{============================================================================}
PROCEDURE Cache_Aiguille2(Xa2, Ya2 : Real);

Begin
     SetColor(1);
     SetLineStyle(0, 0, 3);
     Line(X0,Y0,Round(Xp),Round(Yp));
End;
{============================================================================}
PROCEDURE Dessine_Aiguille3(Xa3, Ya3 : Real);

Begin
     Xp := Xa3;   Yp := Ya3;
     SetColor(15);
     Line(X0,Y0,Round(Xp),Round(Yp));
End;
{============================================================================}
PROCEDURE Cache_Aiguille3(Xa3, Ya3 : Real);

Begin
     SetColor(1);
     Line(X0,Y0,Round(Xp),Round(Yp));
End;
{============================================================================}
PROCEDURE Initialisation_Graphique;

Begin
     Driver := Detect;
     InitGraph(Driver, Mode, 'C:\TP7\BGI');
     if GraphResult < 0 then
     Halt(1);
End;
{============================================================================}
{====================== Programme Principal ================================}

Begin
     Xa1 := 310; Ya1 := 178; { Coordonnes de l'extrmit suprieurr de l'aiguille1 }
     Xa2 := 310; Ya2 := 128; { Coordonnes de l'extrmit suprieurr de l'aiguille2 }
     Xa3 := 310; Ya3 := 78;  { Coordonnes de l'extrmit suprieurr de l'aiguille3 }
        Initialisation_Graphique;
        Dessine_Montre;
        GetTime(Heure, Minute, Seconde, Centieme);
{   Heure:=1;  Minute:=15; Seconde:=55;            }

        If (Heure=1) Or (Heure=13) Then  Alfa1 := 30 + Minute/2;
        If (Heure=2) Or (Heure=14) Then  Alfa1 := 60 + Minute/2;
        If (Heure=3) Or (Heure=15) Then  Alfa1 := 90 + Minute/2;
        If (Heure=4) Or (Heure=16) Then  Alfa1 := 120 + Minute/2;
        If (Heure=5) Or (Heure=17) Then  Alfa1 := 150 + Minute/2;
        If (Heure=6) Or (Heure=18) Then  Alfa1 := 180 + Minute/2;
        If (Heure=7) Or (Heure=19) Then  Alfa1 := 210 + Minute/2;
        If (Heure=8) Or (Heure=20) Then  Alfa1 := 240 + Minute/2;
        If (Heure=9) Or (Heure=21) Then  Alfa1 := 270 + Minute/2;
        If (Heure=10) Or (Heure=22) Then  Alfa1 := 300 + Minute/2;
        If (Heure=11) Or (Heure=23) Then  Alfa1 := 330 + Minute/2;
        If (Heure=12) Or (Heure=24) Then  Alfa1 := 360 + Minute/2;

        Alfa2 := Minute*6;
        Alfa3 := Seconde*6;
        Boule(Round(X0),Round(Y0),5,15,5);

        Rotation(X0, Y0, Xa1, Ya1, Alfa1);
        Dessine_Aiguille1(Xp,Yp);

        Rotation(X0, Y0, Xa2, Ya2, Alfa2);
        Dessine_Aiguille2(Xp,Yp);

        Rotation(X0, Y0, Xa3, Ya3, Alfa3);
        Dessine_Aiguille3(Xp,Yp);

        k := 0;

        Repeat
              Boule(Round(X0),Round(Y0),5,15,5);

              Rotation(X0, Y0, Xa1, Ya1, Alfa1);
              Dessine_Aiguille1(Xp,Yp);

              Rotation(X0, Y0, Xa3, Ya3, Alfa3);
              Dessine_Aiguille3(Xp,Yp);

              Delay(1000);
              Cache_Aiguille1(Xp,Yp);
              Cache_Aiguille2(Xp,Yp);
              Cache_Aiguille3(Xp,Yp);
             { Alfa1 := Alfa1 + 30;}
              
              Alfa3 := Alfa3 + 6;
              If Alfa3 = (Alfa3 + 360) Then
                                       Begin
                                            Alfa2 := Alfa2 + 6;
                                            Rotation(X0, Y0, Xa2, Ya2, Alfa2);
                                            Dessine_Aiguille2(Xp,Yp);
                                       End;
              {Xa1:=Xp ; Ya1:=Yp;
              Xa2:=Xp ; Ya2:=Yp;
              Xa3:=Xp ; Ya3:=Yp;}
        Until KeyPressed;

        CloseGraph;
End.
